# emacs-mode: -*- python-*-
from reportlab.platypus import BaseDocTemplate, SimpleDocTemplate, Paragraph, Spacer, Table, Image, XPreformatted, PageBreak, PageTemplate, Frame, Preformatted
from reportlab.lib.styles import getSampleStyleSheet, ParagraphStyle
from reportlab.lib import colors
from reportlab.lib import pagesizes
from reportlab.lib.units import cm
import PIL.Image
class Memoria:
    __module__ = __name__

    def __init__(self, instalacion):
        self.instalacion = instalacion
        self.listaHorizontal = []
        self.numPagina = 1
        self.numeroTotal = str(self.dameNumTotalPag())
        if (len(self.instalacion.calculosJustificativos) == 0):
            self.listaHorizontal.append(self.inicioHorizontal)
        else:
            numero = self.inicioHorizontal
            for hoja in self.instalacion.calculosJustificativos:
                listo = 0
                indice = 0
                while (not listo):
                    indice = (indice + 22)
                    self.listaHorizontal.append(numero)
                    listo = 1
                    if (len(hoja.datosCircuitos) > indice):
                        listo = 0
                        numero = (numero + 1)

                numero = (numero + 1)

        self.elementosPDF = ElementosPDF(self.instalacion)
        tipoDocumentoHorizontal = pagesizes.landscape(pagesizes.A4)
        tipoDocumento = pagesizes.A4
        self.documento = BaseDocTemplate('datos/memoria.pdf', pagesize=tipoDocumento)
        self.documento.topMargin = 40
        self.documento.leftMargin = 75
        self.documento.height = 750
        frame = Frame(self.documento.leftMargin, self.documento.topMargin, self.documento.width, self.documento.height, id='normal')
        self.documento.addPageTemplates([PageTemplate(id='vertical', frames=[frame], onPage=self.cambia)])
        frame = Frame(200, -200, self.documento.width, self.documento.height, id='normal')
        self.documento.addPageTemplates([PageTemplate(id='horizontal', frames=[frame], onPage=self.cambia)])
        self.contenido = []
        listo = 0
        indice = 0
        while (not listo):
            self.dibujaPagina1(indice)
            indice = (indice + 18)
            self.numPagina = (self.numPagina + 1)
            self.contenido.append(PageBreak())
            listo = 1
            if (len(self.instalacion.receptoresAlumbrado) > indice):
                listo = 0
            if (len(self.instalacion.receptoresFuerza) >= indice):
                listo = 0

        self.dibujaPagina2()
        self.numPagina = (self.numPagina + 1)
        self.contenido.append(PageBreak())
        self.dibujaPagina3()
        self.numPagina = (self.numPagina + 1)
        self.contenido.append(PageBreak())
        self.dibujaPagina4()
        self.numPagina = (self.numPagina + 1)
        self.contenido.append(PageBreak())
        if (len(self.instalacion.calculosJustificativos) == 0):
            self.dibujaPagina5()
            self.numPagina = (self.numPagina + 1)
            self.contenido.append(PageBreak())
            self.dibujaPagina6()
            self.numPagina = (self.numPagina + 1)
            self.contenido.append(PageBreak())
        else:
            for hoja in self.instalacion.calculosJustificativos:
                listo = 0
                indice = 0
                while (not listo):
                    self.dibujaPagina5(hoja, indice)
                    self.contenido.append(PageBreak())
                    indice = (indice + 22)
                    self.numPagina = (self.numPagina + 1)
                    listo = 1
                    if (len(hoja.datosCircuitos) > indice):
                        listo = 0


            for hoja in self.instalacion.calculosJustificativos:
                self.dibujaPagina6(hoja)
                self.numPagina = (self.numPagina + 1)
                self.contenido.append(PageBreak())

        if ((self.instalacion.textoCroquis == '') and (len(self.instalacion.imagenesCroquis) == 0)):
            self.dibujaPagina7()
        else:
            if (self.instalacion.textoCroquis != ''):
                self.dibujaPagina7(self.instalacion.textoCroquis, 'texto')
                self.numPagina = (self.numPagina + 1)
            for imagen in self.instalacion.imagenesCroquis:
                self.dibujaPagina7(imagen, 'imagen')
                self.numPagina = (self.numPagina + 1)

        self.documento.build(self.contenido)



    def dameNumTotalPag(self):
        self.inicioHorizontal = 4
        numero = 5
        if (len(self.instalacion.calculosJustificativos) == 0):
            numero += 1
        for hoja in self.instalacion.calculosJustificativos:
            listo = 0
            indice = 0
            while (not listo):
                indice = (indice + 22)
                listo = 1
                if (len(hoja.datosCircuitos) > indice):
                    listo = 0
                    numero = (numero + 1)

            numero = (numero + 1)

        if (len(self.instalacion.calculosJustificativos) > 1):
            numero = (numero + (len(self.instalacion.calculosJustificativos) - 1))
        img = len(self.instalacion.imagenesCroquis)
        if ((self.instalacion.textoCroquis == '') and (img > 1)):
            numero = (numero + (img - 1))
        if ((self.instalacion.textoCroquis != '') and (img > 0)):
            numero = (numero + img)
        listo = 0
        indice = 0
        while (not listo):
            indice = (indice + 18)
            numero = (numero + 1)
            self.inicioHorizontal = (self.inicioHorizontal + 1)
            listo = 1
            if (len(self.instalacion.receptoresAlumbrado) > indice):
                listo = 0
            if (len(self.instalacion.receptoresFuerza) >= indice):
                listo = 0

        return numero



    def cambia(self, canvas, doc):
        if (doc.page in self.listaHorizontal):
            canvas.setPageSize(pagesizes.landscape(pagesizes.A4))
        if ((doc.page + 1) in self.listaHorizontal):
            self.documento.handle_nextPageTemplate('horizontal')
        else:
            self.documento.handle_nextPageTemplate('vertical')



    def dibujaPagina1(self, indice):
        self.contenido.append(Image('imagenes/cabeceraMemoria.bmp', 550, 85))
        self.contenido.append(self.elementosPDF.dibujaTitular())
        self.contenido.append(Spacer((0.10000000000000001 * cm), (0.10000000000000001 * cm)))
        self.contenido.append(self.elementosPDF.dibujaRedactor())
        self.contenido.append(Spacer((0.10000000000000001 * cm), (0.10000000000000001 * cm)))
        self.contenido.append(self.elementosPDF.dibujaDatosInstalacion())
        self.contenido.append(Spacer((0.10000000000000001 * cm), (0.10000000000000001 * cm)))
        self.contenido.append(self.elementosPDF.dibujaDatosPotencia())
        self.contenido.append(Spacer((0.10000000000000001 * cm), (0.10000000000000001 * cm)))
        self.contenido.append(self.elementosPDF.dibujaRelacionNominal(indice))
        self.contenido.append(Spacer((0.20000000000000001 * cm), (0.20000000000000001 * cm)))
        self.contenido.append(self.elementosPDF.dibujaNotas('(1) Para locales de p\xfablica concurrencia calcul\xe1ndose la ocupaci\xf3n prevista como 1 persona por cada 0,8 m<super>2</super> de superficie \xfatil,excepto pasillos, vestibulos y servicios\n(2) Seg\xfan la clasificaci\xf3n de la tabla del ep\xedgrafe 3.1 de la ITC-BT-04\n(3) Se indicar\xe1n los receptores previstos para instalar, tanto en alumbrado como en fuerza, detall\xe1ndose \xe9stos \xfaltimos hasta una potencia unitaria de 500 W., para el resto de\n receptores de fuerza se podr\xe1 indicar la potencia global prevista para los mismos aclar\xe1ndose, entre par\xe9ntesis, cuales ser\xe1n estos receptores de fuerza a instalar.'))
        self.contenido.append(Spacer((0.69999999999999996 * cm), (0.69999999999999996 * cm)))
        self.contenido.append(self.elementosPDF.dibujaPie(numero=str(self.numPagina), total=self.numeroTotal))



    def dibujaPagina2(self):
        self.contenido.append(self.elementosPDF.dibujaPrevisionPotencia())
        self.contenido.append(Spacer((0.10000000000000001 * cm), (0.10000000000000001 * cm)))
        self.contenido.append(self.elementosPDF.dibujaCargaTotal())
        self.contenido.append(Spacer((0.10000000000000001 * cm), (0.10000000000000001 * cm)))
        self.contenido.append(self.elementosPDF.dibujaNotas('(1) Para la determinacion de la prevision de carga se seguir\xe1n las indicaciones de la ITC-BT-10\n(2) Se incluir\xe1n tanto las viviendas que posean instalaci\xf3n completa como aqu\xe9llas en las que se haya ejecutado la instalaci\xf3n el\xe9ctrica para atender a los acumuladores de calor\npero no se hayan montado estos \xfaltimos'))
        self.contenido.append(Spacer((8 * cm), (8 * cm)))
        self.contenido.append(self.elementosPDF.dibujaPie(numero=str(self.numPagina), total=self.numeroTotal))



    def dibujaPagina3(self):
        self.contenido.append(self.elementosPDF.dibujaAmpliaciones())
        self.contenido.append(Spacer((0.10000000000000001 * cm), (0.10000000000000001 * cm)))
        self.contenido.append(self.elementosPDF.dibujaMemoriaDescriptiva())
        self.contenido.append(Spacer((0.10000000000000001 * cm), (0.10000000000000001 * cm)))
        self.contenido.append(self.elementosPDF.dibujaNotas("(1) Se especificar\xe1 si es vivienda, local u oficina, indicando piso y puerta, o si es uno de los servicios generales indic\xe1ndolo (ascensor, garaje, alumbrado, etc)\n(2) Se incluir\xe1n tanto las viviendas que posean instalaci\xf3n completa como aquellas en las que se haya ejecutado la instalaci\xf3n el\xe9ctrica para atender a los acumuladores\nde calor pero no se hayan montado \xe9stos \xfaltimos\n(3) Se indicar\xe1 la propiedad de la red de distribuci\xf3n que suminstra a la instalaci\xf3n que se describe en la Memoria, denomin\xe1ndose: a) Red de distribuci\xf3n de emepresa\ndistribuidora (R.D.D.), b) Centro de transformaci\xf3n de empresa distribuidora (C.T.D.), c) Red de distribuci\xf3n privada (R.P.D.) d) Centro de transformaci\xf3n privado\n(C.T.P.), e) Centro de transformaci\xf3n del titular de la instalaci\xf3n (C.T.T.), y f) Otros (Otros) deber\xe1n describirse en el apartado '6 Aclaraciones a la Memoria'\n(4) Se indicar\xe1 la intensidad de cortocircuito de la red de distribuci\xf3n facilitada por la empresa distribuidora, segun art. 15 del Rgto. Elect. para Baja Tensi\xf3n e I.T.C.\n(5) Para suminstros monof\xe1sicos se indicar\xe1 la tensi\xf3n simple (ejem 230 V ), para suministros trif\xe1sicos a cuatro hilos se indicar\xe1 la tensi\xf3n compuesta y simple (ejem\n400/230 V) y para suministros trif\xe1sicos a tres hilos se indicar\xe1 la tensi\xf3n compuesta por el numero de fases (ejem 3x230 V)\n(6) Se especificar\xe1 seg\xfan ITC-BT-14 apartado 1 e ITC-BT-15 apartado 1\n(7) En el caso de existir m\xe1s de una Derivaci\xf3n Individual, se indicar\xe1n los datos correspondientes a cada Derivaci\xf3n Individual en el apartado '6. Aclaraciones a la\nMemoria', deviendo quedar las Derivaciones Individales perfectamente identificadas\n(8) Se indicar\xe1n los fusibles de protecci\xf3n a instalar para cada Derivaci\xf3n Individual a viviendas, garajes, locales, etc en edificios de viviendas, centros comerciales, etc\n(9) Se especificar\xe1 si procede\n(10) Se especificar\xe1n los tipos de protecciones a instalar tanto en el Cuadro General de Protecci\xf3n como otros cuadrados secundarios de la instalacion el\xe9ctrica\n(11) Se indicar\xe1 el tipo de protecci\xf3n contra contactos indirectos seg\xfan apartado 4 de la ITC-BT-24\n(12) Se especificar\xe1 la composici\xf3n de los electrodos y profundidad de enterramiento, seg\xfan lo establecido en la ITC-BT-18 apartado 3.1\n(13) Se indicar\xe1 tipo, secci\xf3n y naturaleza del conductor seg\xfan lo establecido en la tabla 1 de la ITC-BT-18"))
        self.contenido.append(Spacer((0.69999999999999996 * cm), (0.69999999999999996 * cm)))
        self.contenido.append(self.elementosPDF.dibujaPie(numero=str(self.numPagina), total=self.numeroTotal))



    def dibujaPagina4(self):
        self.contenido.append(self.elementosPDF.dibujaAclaraciones())
        self.contenido.append(Spacer((0.69999999999999996 * cm), (0.69999999999999996 * cm)))
        self.contenido.append(self.elementosPDF.dibujaPie(numero=str(self.numPagina), total=self.numeroTotal))



    def dibujaPagina5(self, hoja = None, indice = None):
        self.contenido.append(self.elementosPDF.dibujaTablaCalculosJustificativos(hoja, indice))
        self.contenido.append(Spacer((0.20000000000000001 * cm), (0.20000000000000001 * cm)))
        self.contenido.append(self.elementosPDF.dibujaNotas('               C.d.T. = Caida de tensi\xf3n     I. m\xe1x = Intensidad m\xe1xima     Adm = Admisible      Coef. de Calc. = Coeficiente de c\xe1lculo     Prot. Sobre = Protecci\xf3n contra sobreintensidades      Prot. Dif. = Protecci\xf3n diferencial', horizontal=1))
        self.contenido.append(Spacer((0.20000000000000001 * cm), (0.20000000000000001 * cm)))
        self.contenido.append(self.elementosPDF.dibujaNotas("(1)Podr\xe1n utilizarse tantas hojas de tabla de c\xe1lculos justificativos como sean necesarias por el redactor de la presente Memoria T\xe9cnica de Dise\xf1o.\n(2) Se identificar\xe1 la l\xednea que se calcula: L\xednea General de Alimentaci\xf3n (L.G.A.), Derivaci\xf3n Individual (D.I.) o Circuito interior (C).\n                   *Si existen varias l\xedneas del mismo tipo se distinguir\xe1n a\xf1adiendo el correspondiente n\xfamero de orden (Ej.:D.I.1, D.I.2, D.I.3...).\n                  *Cuando existan varias l\xedneas con la misma finalidad y caracter\xedsticas id\xe9nticas (p. Ej. derivaciones individuales de igual longitud y potencia), s\xf3lo ser\xe1 preciso calcular una de ellas, debiendo indicarse en el apartado de\n                               'Observaciones' cuales son las l\xedneas id\xe9nticas a la calculada, especificando para ello las viviendas, locales, oficinas o servicios correspondientes.\n                   *En el caso de viviendas, locales, oficinas o servicios de instalaciones interiores id\xe9nticas, s\xf3lo ser\xe1 necesario calcular una de ellas, indicando en el apartado de \x93Observaciones\x94 a qu\xe9 instalaciones se extienden los\n                              c\xe1lculos realizados.\n                  *En el caso de viviendas los circuitos interiores se identificar\xe1n siguiendo la nomenclatura establecida en los puntos 2.3.1. y 2.3.2. de la ITC-BT-25. Para distinguir los mismos circuitos de varias viviendas se a\xf1adir\xe1 al\n                             nombre del circuito el de la vivienda (Ej.: C1-Vivienda tipo A, C1 Vivienda tipo B).\n(3) II para circuitos monof\xe1sicos y III para circuitos trif\xe1sicos.\n(4) El coeficiente de c\xe1lculo ser\xe1 el producto de los coeficientes a aplicar por el tipo de montaje y/o disposici\xf3n de los conductores, condiciones ambientales y tipos de receptores a suministrar por la l\xednea seg\xfan establece el\n Reglamento Electrot\xe9cnico para Baja Tensi\xf3n e I.T.C., as\xed como el coeficiente de simultaneidad a considerar para el c\xe1lculo de la l\xednea. En el caso de viviendas, el coeficiente de simultaneidad ser\xe1 el producto del factor de\n simultaneidad y del factor de utilizaci\xf3n definidos en el punto 3 de la ITC-BT-25.\n(5) Se indicar\xe1 la secci\xf3n de los conductores de la l\xednea y del tipo de material del conductor (cobre = Cu, aluminio = Al, Almelec = Al-Ac).\n(6) Se indicar\xe1 el sistema de instalaci\xf3n de la canalizaci\xf3n, conforme a lo establecido en las ITC-BT-20 y ITC-BT-26.", horizontal=1))
        self.contenido.append(Spacer((0.40000000000000002 * cm), (0.40000000000000002 * cm)))
        self.contenido.append(self.elementosPDF.dibujaPie(horizontal=1, numero=str(self.numPagina), total=self.numeroTotal))



    def dibujaPagina6(self, hoja = None):
        self.contenido.append(self.elementosPDF.dibujaEsquemas(hoja))
        self.contenido.append(Spacer((0.69999999999999996 * cm), (0.69999999999999996 * cm)))
        self.contenido.append(self.elementosPDF.dibujaPie(numero=str(self.numPagina), total=self.numeroTotal))



    def dibujaPagina7(self, dato = None, tipo = None):
        self.contenido.append(self.elementosPDF.dibujaCroquis(dato, tipo))
        self.contenido.append(Spacer((0.20000000000000001 * cm), (0.20000000000000001 * cm)))
        self.contenido.append(self.elementosPDF.dibujaNotas('          *Se acompa\xf1a a la Memoria plano de emplazamiento para la correcta localizaci\xf3n de la instalaci\xf3n'))
        self.contenido.append(Spacer((0.20000000000000001 * cm), (0.20000000000000001 * cm)))
        if (not (self.instalacion.fechaFirma == '')):
            datos = self.instalacion.fechaFirma.split('/')
        else:
            datos = ['',
             '',
             '']
        self.contenido.append(self.elementosPDF.dibujaTextos(((((((('          El instalador autorizado en baja tensi\xf3n / t\xe9cnico titulado competente (t\xe1chese lo que no proceda) que ha redactado la\npresente Memoria T\xe9cnica de Dise\xf1o declara que la misma est\xe1 de acuerdo con las prescripciones del vigente Reglamento\nElectrot\xe9cnico para Baja Tensi\xf3n e instrucciones de ITC-BT espec\xedficas que le son de aplicaci\xf3n, as\xed como con las normas particulares de\nla empresa distribuidora oficialmente aprobadas por el Organismo Competente en materia de industria y energ\xeda e instrucciones\ndictadas por dicho Organismos.\n                                                          ' + self.instalacion.lugar) + ' ,a ') + datos[0]) + ' de ') + datos[1]) + ' de ') + datos[2])))
        self.contenido.append(Spacer((3.2000000000000002 * cm), (3.2000000000000002 * cm)))
        self.contenido.append(self.elementosPDF.dibujaNotas('                                         (Firma del redactor de la Memoria T\xe9cnica de Dise\xf1o con el sello del Instalador Autorizado/ Visado)'))
        self.contenido.append(Spacer((0.20000000000000001 * cm), (0.20000000000000001 * cm)))
        self.contenido.append(self.elementosPDF.dibujaPie(numero=str(self.numPagina), total=self.numeroTotal))



    def dibujaPagina8(self):
        self.contenido.append(self.elementosPDF.dibujaTextos('INTRUCCIONES PARA LA CUMPLIMENTACI\xd3N DE LA MEMORIA T\xc9CNICA DE DISE\xd1O:'))
        self.contenido.append(Spacer((0.5 * cm), (0.5 * cm)))
        self.contenido.append(self.elementosPDF.dibujaTextos('A. Generales:'))
        self.contenido.append(Spacer((0.29999999999999999 * cm), (0.29999999999999999 * cm)))
        self.contenido.append(self.elementosPDF.dibujaTextos('\x95\tSe marcar\xe1 con un aspa (\x93X\x94) las casilla (?) que procedan.\n\x95\tSe podr\xe1 cumplimentar la Memoria T\xe9cnica de Dise\xf1o a m\xe1quina o bol\xedgrafo; en este \xfaltimo caso, se rellenar\xe1\n con letra clara y en may\xfasculas de forma que sea perfectamente legible.\n\x95\tNo se admitir\xe1n Memorias T\xe9cnicas de Dise\xf1o con tachaduras y/o con modificaciones sobre la primera escritura\n realizada.\n\x95\tTerminada la Memoria T\xe9cnica de Dise\xf1o el redactor de la misma deber\xe1 numerar las hojas indicando su orden\n y n\xfamero total de hojas que componen la Memoria en el espacio reservado para esto.'))
        self.contenido.append(Spacer((0.5 * cm), (0.5 * cm)))
        self.contenido.append(self.elementosPDF.dibujaTextos('B. Modelo inform\xe1tico:'))
        self.contenido.append(Spacer((0.29999999999999999 * cm), (0.29999999999999999 * cm)))
        self.contenido.append(self.elementosPDF.dibujaTextos('\x95\tSe completar\xe1n los \x93campos de datos\x94 respetando los espacios (celdas) para los datos del formato de la Memoria\nT\xe9cnica de Dise\xf1o.\n\x95\tPara cambiar de un \x93campo de datos\x94 a otro se utilizar\xe1 el tabulador del teclado o se har\xe1 \x93clic\x94 con el bot\xf3n\nizquierdo del rat\xf3n sobre el campo a cumplimentar para activar el mismo.'))
        self.contenido.append(Spacer((0.29999999999999999 * cm), (18 * cm)))
        self.contenido.append(self.elementosPDF.dibujaPie())



class Registro:
    __module__ = __name__

    def __init__(self, instalacion):
        self.elementosPDF = ElementosPDF(instalacion)
        tipoDocumento = pagesizes.A4
        self.documento = SimpleDocTemplate('datos/registro.pdf', pagesize=tipoDocumento)
        self.documento.topMargin = (1.5 * cm)
        self.documento.leftMargin = (1 * cm)
        self.documento.rightMargin = (0.69999999999999996 * cm)
        self.documento.bottomMargin = (2 * cm)
        self.contenido = []
        self.dibujaPagina1()
        self.documento.build(self.contenido)



    def dibujaPagina1(self):
        self.contenido.append(Image('imagenes/cabeceraRegistro.bmp', 550, 90))
        self.contenido.append(self.elementosPDF.dibujaTitularRegistro())
        self.contenido.append(self.elementosPDF.dibujaDatosInstalacionRegistro())
        self.contenido.append(self.elementosPDF.dibujaDocumentacion())
        self.contenido.append(self.elementosPDF.dibujaDatosRegistro())
        self.contenido.append(self.elementosPDF.dibujaOtrasInstalaciones())
        self.contenido.append(Spacer((0.10000000000000001 * cm), (0.10000000000000001 * cm)))
        self.contenido.append(self.elementosPDF.dibujaTextos('<b>SERVICIO DE ORDENACI\xd3N INDUSTRIAL ENERG\xcdA Y MINAS</b>'))



    def dibujaPagina2(self):
        self.contenido.append(self.elementosPDF.dibujaTextos('LLAMADAS E INSTRUCIONES PARA LA CUMPLIMENTACI\xd3N DE LA SOLICITUD DE REGISTRO:'))
        self.contenido.append(Spacer((0.5 * cm), (0.5 * cm)))
        self.contenido.append(self.elementosPDF.dibujaTextos('A.-Llamadas realizadas en Solicitud de Registro:'))
        self.contenido.append(Spacer((0.29999999999999999 * cm), (0.29999999999999999 * cm)))
        self.contenido.append(self.elementosPDF.dibujaTextos('<b>(1)</b> Deber\xe1 presentarse documentaci\xf3n que acredite la representaci\xf3n o apoderamiento.\n<b>(2)</b> Para locales de p\xfablica concurrencia calcul\xe1ndose la ocupaci\xf3n prevista como 1 persona por cada 0,8 m2 de\n superficie \xfatil, excepto pasillos, vest\xedbulos y servicios.\n<b>(3)</b> Seg\xfan la clasificaci\xf3n de la tabla del ep\xedgrafe 3.1 de la ITC-BT-04.\n<b>(4)</b> Para viviendas y otras instalaciones donde se desconozca la potencia el\xe9ctrica de los receptores instalados, se\n calcular\xe1 la potencia prevista a instalar seg\xfan lo indicado en la ITC-BT-10.\n<b>(5)</b> se especificar\xe1 si procede.'))
        self.contenido.append(Spacer((0.5 * cm), (0.5 * cm)))
        self.contenido.append(self.elementosPDF.dibujaTextos('B.- Instrucciones para la cumplimentaci\xf3n de la Solicitud de Registro.'))
        self.contenido.append(Spacer((0.29999999999999999 * cm), (0.29999999999999999 * cm)))
        self.contenido.append(self.elementosPDF.dibujaTextos('b.1. Generales:'))
        self.contenido.append(Spacer((0.29999999999999999 * cm), (0.29999999999999999 * cm)))
        self.contenido.append(self.elementosPDF.dibujaTextos('\x95\tSe marcar\xe1 con un aspa (\x93X\x94) las casilla (?) que procedan.\n\x95\tSe podr\xe1 cumplimentar la solicitud de registro a m\xe1quina o bol\xedgrafo; en este \xfaltimo caso, se rellenar\xe1 con letra clara\n y en may\xfasculas de forma que sea perfectamente legible.\n\x95\tNo se admitir\xe1n solicitudes de registro con tachaduras y/o con modificaciones sobre la primera escritura realizada.'))
        self.contenido.append(Spacer((0.29999999999999999 * cm), (0.29999999999999999 * cm)))
        self.contenido.append(self.elementosPDF.dibujaTextos('b.2. Modelo inform\xe1tico:'))
        self.contenido.append(Spacer((0.29999999999999999 * cm), (0.29999999999999999 * cm)))
        self.contenido.append(self.elementosPDF.dibujaTextos('\x95\tSe completar\xe1n los \x93campos de datos\x94 respetando los espacios (celdas) para los datos del formato del impreso\n de solicitud.\n\x95\tPara cambiar de un \x93campo de datos\x94 a otro se utilizar\xe1 el tabulador del teclado o se har\xe1 \x93clic\x94 con el bot\xf3n\n izquierdo del rat\xf3n sobre el campo a cumplimentar para activar el mismo.'))



class Certificado:
    __module__ = __name__

    def __init__(self, instalacion):
        self.elementosPDF = ElementosPDF(instalacion)
        tipoDocumento = pagesizes.A4
        self.documento = SimpleDocTemplate('datos/certificado.pdf', pagesize=tipoDocumento)
        self.documento.topMargin = (1.5 * cm)
        self.documento.leftMargin = (1 * cm)
        self.documento.rightMargin = (0.69999999999999996 * cm)
        self.documento.bottomMargin = (2 * cm)
        self.contenido = []
        self.dibujaPagina1()
        self.documento.build(self.contenido)



    def dibujaPagina1(self):
        self.contenido.append(Image('imagenes/cabeceraCertificado.bmp', 550, 90))
        self.contenido.append(self.elementosPDF.dibujaTitularCertificado())
        self.contenido.append(self.elementosPDF.dibujaDatosInstalacionCertificado())
        self.contenido.append(self.elementosPDF.dibujaCaracteristicasGenerales())
        self.contenido.append(Spacer((0.10000000000000001 * cm), (0.10000000000000001 * cm)))
        self.contenido.append(self.elementosPDF.dibujaTextos('<b>SERVICIO DE ORDENACI\xd3N INDUSTRIAL ENERG\xcdA Y MINAS</b>'))



    def dibujaPagina2(self):
        self.contenido.append(self.elementosPDF.dibujaTextos('LLAMADAS E INSTRUCCIONES PARA LA CUMPLIMENTACI\xd3N DEL CERTIFICADO DE INSTALACI\xd3N EL\xc9CTRICA DE BAJA\n TENSI\xd3N:'))
        self.contenido.append(Spacer((0.5 * cm), (0.5 * cm)))
        self.contenido.append(self.elementosPDF.dibujaTextos('A.- Llamadas realizadas en el Certificado de Instalaci\xf3n El\xe9ctrica de Baja Tensi\xf3n:'))
        self.contenido.append(Spacer((0.29999999999999999 * cm), (0.29999999999999999 * cm)))
        self.contenido.append(self.elementosPDF.dibujaTextos("<b>(1)</b> Para locales de p\xfablica concurrencia calcul\xe1ndose la ocupaci\xf3n prevista como 1 persona por cada 0,8 m2 de superficie \xfatil, excepto\npasillos, vest\xedbulos y servicios.\n<b>(2)</b> Seg\xfan la clasificaci\xf3n de la tabla del ep\xedgrafe 3.1 de la ITC-BT-04.\n<b>(3)</b> Siempre que no se produzcan modificaciones significativas, entendiendo como tales las que afecten a la potencia prevista, tensiones\n de servicio y utilizaci\xf3n, y a los elementos de la protecci\xf3n contra contactos directos e indirectos y contra sobreintensidades\n  y sobretensiones.\n<b>(4)</b> Se especificar\xe1 si procede. Los datos correspondientes a la L\xednea General de Alimentaci\xf3n se especificar\xe1n en aquellas instalaciones\n (edificios de viviendas, edificios comerciales, etc.) donde esta l\xednea exista, seg\xfan se establece en la ITC-BT-12.\n<b>(5)</b> Se especificar\xe1 el sistema de instalaci\xf3n empleado seg\xfan ITC-BT-14 apartado 1 e ITC-BT-15 apartado 1, seg\xfan corresponda.\n<b>(6)</b> Se especificar\xe1 esta casilla cuando existan fusibles para protecci\xf3n de la Derivaci\xf3n Individual en centralizaci\xf3n de contadores y \xe9stos\n sean, por tanto, independientes de los instalados en la Caja General de Protecci\xf3n.\n<b>(7)</b> Para suministros monof\xe1sicos se indicar\xe1 la tensi\xf3n simple (ejm.: 230 V.), para suministros trif\xe1sicos a cuatro hilos se indicar\xe1\n la tensi\xf3n compuesta y simple (ejm.:400/230 V.) y para suministros trif\xe1sicos a tres hilos se indicar\xe1 la tensi\xf3n compuesta por el n\xfamero\n de fases(ejm.: 3x230 V.).\n<b>(8)</b> La \x93Potencia M\xe1xima a contratar\x94 vendr\xe1 determinada por las potencias a contratar normalizadas por las empresas distribuidoras\n en funci\xf3n de la gama de intensidades normalizadas de sus interruptores de control de potencia, transformadores de intensidad\n normalizados, etc. Por lo tanto, el valor m\xe1ximo de la \x93Potencia M\xe1xima a contratar\x94 que se podr\xe1 establecer para cada instalaci\xf3n\n ser\xe1 la potencia a contratar normalizada por la empresa distribuidora inmediatamente superior a la potencia Instalada o prevista de\n receptores en el emplazamiento (industria, comercio, garaje, viviendas, oficinas, etc.), no pudiendo ser, en ning\xfan caso, la \x93potencia\n M\xe1xima a contratar\x94 superior a la Potencia M\xe1xima Admisible de la Derivaci\xf3n Individual de la instalaci\xf3n.\n        En aquellas instalaciones donde existan receptores instalados con una sobreintensidad de arranque elevada se podr\xe1 establecer\nuna 'Potencia M\xe1xima a contratar' superior a la indicada en el p\xe1rrafo anterior siempre que \xe9sta quede justificada en la Memoria\n T\xe9cnica de Dise\xf1o Proyecto T\xe9cnico correspondiente, no obstante, la 'Potencia M\xe1xima a contratar' calculada deber\xe1 ajustarse al\n valor superior m\xe1s pr\xf3ximo de las potencias a contratar normalizadas por las empresas distribuidoras y en ning\xfan caso podr\xe1 ser\nsuperior a la Potencia M\xe1xima Admisible de la Derivaci\xf3n Individual de la instalaci\xf3n\n<b>(9)</b> Potencia M\xe1xima Admisible de la Derivaci\xf3n Individual seg\xfan ITC-BT-12 e ITC-BT-15.\n<b>(10)</b> Se especificar\xe1n las caracter\xedsticas de las protecciones instaladas tanto en el Cuadro General de Protecci\xf3n como otros cuadros\n secundarios de la instalaci\xf3n.\n<b>(11)</b> Se indicar\xe1 el tipo de protecci\xf3n contra contactos indirectos seg\xfan apartado 4 de la ITC-BT-24.\n<b>(12)</b> Se indicar\xe1 tipo, secci\xf3n y naturaleza del conductor seg\xfan lo establecido en la tabla 1 de la ITC-BT-18."))
        self.contenido.append(Spacer((0.5 * cm), (0.5 * cm)))
        self.contenido.append(self.elementosPDF.dibujaTextos('B. Instrucciones para la cumplimentaci\xf3n del Certificado de Instalaci\xf3n El\xe9ctrica de Baja Tensi\xf3n:'))
        self.contenido.append(Spacer((0.5 * cm), (0.5 * cm)))
        self.contenido.append(self.elementosPDF.dibujaTextos('b.1. Generales:'))
        self.contenido.append(Spacer((0.29999999999999999 * cm), (0.29999999999999999 * cm)))
        self.contenido.append(self.elementosPDF.dibujaTextos('\x95\tSe marcar\xe1 con un aspa (\x93X\x94) las casilla (?) que procedan.\n\x95\tSe podr\xe1 cumplimentar el Certificado a m\xe1quina o bol\xedgrafo; en este \xfaltimo caso, se rellenar\xe1 con letra clara y en may\xfasculas de forma que\nsea perfectamente legible.\n\x95\tNo se admitir\xe1n Certificados de Instalaci\xf3n de Baja Tensi\xf3n de Dise\xf1o con tachaduras y/o con modificaciones sobre la primera escritura\n realizada.'))
        self.contenido.append(Spacer((0.29999999999999999 * cm), (0.29999999999999999 * cm)))
        self.contenido.append(self.elementosPDF.dibujaTextos('b.2. Modelo inform\xe1tico:'))
        self.contenido.append(Spacer((0.29999999999999999 * cm), (0.29999999999999999 * cm)))
        self.contenido.append(self.elementosPDF.dibujaTextos('\x95\tSe completar\xe1n los \x93campos de datos\x94 respetando los espacios (celdas) reservados para los datos en el formato del impreso del Certificado.\n\x95\tPara cambiar de un \x93campo de datos\x94 a otro se utilizar\xe1 el tabulador del teclado o se har\xe1 \x93clic\x94 con el bot\xf3n izquierdo del rat\xf3n sobre el\ncampo a cumplimentar para activar el mismo.'))



class Portada:
    __module__ = __name__

    def __init__(self, instalacion):
        self.elementosPDF = ElementosPDF(instalacion)
        tipoDocumento = pagesizes.A4
        self.documento = SimpleDocTemplate('datos/portada.pdf', pagesize=tipoDocumento)
        self.documento.topMargin = (1.5 * cm)
        self.documento.leftMargin = (1 * cm)
        self.documento.rightMargin = (0.69999999999999996 * cm)
        self.documento.bottomMargin = (2 * cm)
        self.contenido = []
        self.dibujaPagina1()
        self.documento.build(self.contenido)



    def dibujaPagina1(self):
        self.contenido.append(self.elementosPDF.dibujaPortada())



class ElementosPDF:
    __module__ = __name__

    def __init__(self, instalacion):
        self.instalacion = instalacion
        estilos = getSampleStyleSheet()
        self.misestilos = getSampleStyleSheet()
        self.eNormal = ParagraphStyle(name='normal', parent=estilos['Normal'], fontName='Times-Roman', fontSize=7.5, leading=8.5, alignment=0)
        self.eNormalTexto = ParagraphStyle(name='normal', parent=estilos['Normal'], fontName='Times-Roman', fontSize=10, leading=8.5, alignment=0)
        self.eNormalPortada = ParagraphStyle(name='normal', parent=estilos['Normal'], fontName='Times-Roman', fontSize=14, leading=10, alignment=0)
        self.eNormalCentrado = ParagraphStyle(name='notas', parent=self.eNormal, fontName='Times-Roman', fontSize=7.5, leading=7, alignment=1)
        self.eNormalCentrado2 = ParagraphStyle(name='notas', parent=self.eNormal, fontName='Times-Roman', fontSize=7.5, leading=8.5, alignment=1)
        self.eNormalCentrado3 = ParagraphStyle(name='notas', parent=self.eNormal, fontName='Times-Roman', fontSize=7.5, leading=10.5, alignment=1)
        self.eLista = ParagraphStyle(name='notas', parent=self.eNormal, fontName='Times-Bold', fontSize=8.5, leading=7.5, alignment=1)
        self.eCabecera = ParagraphStyle(name='head', parent=self.eNormal, fontName='Times-Bold', fontSize=9.5, alignment=0)
        self.eNormalPequenio = ParagraphStyle(name='notas', parent=self.eNormal, fontName='Times-Roman', fontSize=9, leading=8, alignment=0)
        self.eCabeceraPortada = ParagraphStyle(name='head', parent=self.eNormal, fontName='Times-Bold', fontSize=20, alignment=0)
        self.eTituloPortada = ParagraphStyle(name='head', parent=self.eNormal, fontName='Times-Bold', fontSize=40, alignment=1, leading=40)
        self.eNormalSalto = ParagraphStyle(name='notas', parent=self.eNormal, fontName='Times-Roman', fontSize=7.5, leading=10.5, alignment=0)
        self.eFirma = ParagraphStyle(name='notas', parent=self.eNormal, fontName='Times-Roman', fontSize=16, leading=10.5, alignment=2)
        self.eNormalSaltoCentrado = ParagraphStyle(name='notas', parent=self.eNormal, fontName='Times-Roman', fontSize=7.5, leading=10.5, alignment=1)
        self.eNormalSaltoCentrado2 = ParagraphStyle(name='notas', parent=self.eNormal, fontName='Times-Bold', fontSize=7, leading=9, alignment=0)
        self.eNormalSalto2 = ParagraphStyle(name='notas', parent=self.eNormal, fontName='Times-Roman', fontSize=7.5, leading=12.5, alignment=0)
        self.eNormalSalto3 = ParagraphStyle(name='notas', parent=self.eNormal, fontName='Times-Roman', fontSize=7.5, leading=8, alignment=0)
        self.eNormalSalto4 = ParagraphStyle(name='notas', parent=self.eNormal, fontName='Times-Roman', fontSize=7.5, leading=6, alignment=0)
        self.eNormalSalto5 = ParagraphStyle(name='notas', parent=self.eNormal, fontName='Times-Roman', fontSize=7.5, leading=3, alignment=0)
        self.eCabeceraDoble = ParagraphStyle(name='headDoble', parent=self.eNormal, fontName='Times-Roman', fontSize=9.5, alignment=0, leading=8.5)
        self.eNotas = ParagraphStyle(name='notas', parent=self.eNormal, fontName='Times-Roman', fontSize=7.5, leading=10, alignment=0)
        self.eTextos = ParagraphStyle(name='textos', parent=self.eNormal, fontName='Times-Roman', fontSize=9.5, leading=10, alignment=0)
        self.ePie = ParagraphStyle(name='pie', parent=self.eNormal, fontName='Times-Roman', fontSize=7.5, leading=7.5, alignment=2)
        self.eTablaInterna = [('LINEAFTER',
          (0,
           0),
          (-1,
           -1),
          0.25,
          colors.black),
         ('TOPPADDING',
          (0,
           0),
          (-1,
           -1),
          0),
         ('LEFTPADDING',
          (1,
           0),
          (-1,
           -1),
          0),
         ('RIGHTPADDING',
          (1,
           0),
          (-1,
           -1),
          0),
         ('VALIGN',
          (0,
           0),
          (-1,
           -1),
          'CENTER'),
         ('BOTTOMPADDING',
          (0,
           0),
          (-1,
           -1),
          0)]
        self.eTablaSubrayada = [('LINEAFTER',
          (0,
           0),
          (-1,
           -1),
          0.25,
          colors.black),
         ('TOPPADDING',
          (0,
           0),
          (-1,
           -1),
          0),
         ('RIGHTPADDING',
          (0,
           0),
          (-1,
           -1),
          0),
         ('VALIGN',
          (0,
           0),
          (-1,
           -1),
          'TOP'),
         ('BOTTOMPADDING',
          (0,
           0),
          (-1,
           -1),
          0),
         ('LINEBELOW',
          (0,
           0),
          (-1,
           -1),
          0.25,
          colors.black)]
        self.eTablaInterna2 = [('LINEAFTER',
          (0,
           0),
          (-1,
           -1),
          0.25,
          colors.black),
         ('TOPPADDING',
          (0,
           0),
          (-1,
           -1),
          0),
         ('VALIGN',
          (0,
           0),
          (-1,
           -1),
          'CENTER'),
         ('ALIGN',
          (0,
           0),
          (-1,
           -1),
          'CENTER'),
         ('BOTTOMPADDING',
          (0,
           0),
          (-1,
           -1),
          0)]
        self.eTablaInterna3 = [('LINEAFTER',
          (0,
           0),
          (-1,
           -1),
          0.25,
          colors.black),
         ('TOPPADDING',
          (0,
           0),
          (-1,
           -1),
          0),
         ('VALIGN',
          (0,
           0),
          (-1,
           -1),
          'CENTER'),
         ('ALIGN',
          (0,
           0),
          (-1,
           -1),
          'CENTER')]
        self.eTablaSinCeldas = [('TOPPADDING',
          (0,
           0),
          (-1,
           -1),
          0),
         ('RIGHTPADDING',
          (0,
           0),
          (-1,
           -1),
          0),
         ('VALIGN',
          (0,
           0),
          (-1,
           -1),
          'TOP'),
         ('BOTTOMPADDING',
          (0,
           0),
          (-1,
           -1),
          0)]
        self.eTablaInternaArriba = [('LINEAFTER',
          (0,
           0),
          (-1,
           -1),
          0.25,
          colors.black),
         ('TOPPADDING',
          (0,
           0),
          (-1,
           -1),
          0),
         ('LEFTPADDING',
          (1,
           0),
          (-1,
           -1),
          0),
         ('RIGHTPADDING',
          (1,
           0),
          (-1,
           -1),
          0),
         ('VALIGN',
          (0,
           0),
          (0,
           0),
          'CENTER'),
         ('VALIGN',
          (1,
           0),
          (1,
           0),
          'TOP'),
         ('BOTTOMPADDING',
          (0,
           0),
          (-1,
           -1),
          0)]
        self.eTablaNormal2 = [('LINEAFTER',
          (0,
           0),
          (-1,
           -1),
          0.25,
          colors.black),
         ('TOPPADDING',
          (0,
           0),
          (-1,
           -1),
          0),
         ('VALIGN',
          (0,
           0),
          (-1,
           -1),
          'CENTER'),
         ('GRID',
          (-1,
           0),
          (-1,
           0),
          1,
          colors.black)]
        self.eTablaResultado = [('LINEAFTER',
          (0,
           0),
          (-1,
           -1),
          0.25,
          colors.black),
         ('TOPPADDING',
          (0,
           0),
          (-1,
           -1),
          0),
         ('VALIGN',
          (0,
           0),
          (-1,
           -1),
          'CENTER'),
         ('GRID',
          (1,
           0),
          (1,
           0),
          1,
          colors.black),
         ('GRID',
          (3,
           0),
          (3,
           0),
          1,
          colors.black)]
        self.eTablaResultado2 = [('LINEAFTER',
          (0,
           0),
          (-1,
           -1),
          0.25,
          colors.black),
         ('TOPPADDING',
          (0,
           0),
          (-1,
           -1),
          0),
         ('VALIGN',
          (0,
           0),
          (-1,
           -1),
          'CENTER'),
         ('GRID',
          (1,
           0),
          (1,
           0),
          1,
          colors.black)]



    def dibujaTitular(self):
        tabla = []
        tabla.append([Paragraph('<b>1. TITULAR DE LA INSTALACI\xd3N</b>', self.eCabecera)])
        tabla.append([self.dameTabla([(('Nombre o Raz\xf3n Social:\n<b><font size=8.5>' + self.instalacion.nombre) + '</font></b>'),
          (('D.N.I.-C.I.F.:\n<b><font size=8.5>' + self.instalacion.dni) + '</font></b>')], [(15 * cm),
          (4 * cm)])])
        tabla.append([self.dameTabla([(('Domicilio:\n<b><font size=8.5>' + self.instalacion.domicilio) + '</font></b>'),
          (('C\xf3digo Postal:\n<b><font size=8.5>' + self.instalacion.codigoPostal) + '</font></b>')], [(15 * cm),
          (4 * cm)])])
        tabla.append([self.dameTabla([(('Localidad:\n<b><font size=8.5>' + self.instalacion.localidad) + '</font></b>'),
          (('Provincia:\n<b><font size=8.5>' + self.instalacion.provincia) + '</font></b>'),
          (('Correo electr\xf3nico:\n<b><font size=8.5>' + self.instalacion.mail) + '</font></b>'),
          (('Tel\xe9fono:\n<b><font size=8.5>' + self.instalacion.telefono) + '</font></b>')], [(7 * cm),
          (2.5 * cm),
          (5.5 * cm),
          (4 * cm)])])
        t = Table(data=tabla, colWidths=[(19 * cm)], rowHeights=[(0.59999999999999998 * cm),
         (0.69999999999999996 * cm),
         (0.69999999999999996 * cm),
         (0.69999999999999996 * cm)])
        t.setStyle([('GRID',
          (0,
           0),
          (-1,
           -1),
          0.25,
          colors.black),
         ('BACKGROUND',
          (0,
           0),
          (0,
           0),
          colors.Color(0.75, 0.75, 0.75)),
         ('BOTTOMPADDING',
          (0,
           0),
          (-1,
           -1),
          0),
         ('LEFTPADDING',
          (0,
           1),
          (-1,
           -1),
          0),
         ('RIGHTPADDING',
          (0,
           1),
          (-1,
           -1),
          0),
         ('TOPPADDING',
          (0,
           0),
          (-1,
           -1),
          0),
         ('VALIGN',
          (0,
           0),
          (0,
           0),
          'CENTER'),
         ('VALIGN',
          (0,
           1),
          (-1,
           -1),
          'TOP'),
         ('ALIGN',
          (0,
           1),
          (-1,
           -1),
          'CENTER')])
        return t



    def dibujaRedactor(self):
        tabla = []
        tabla.append([Paragraph('<b>2. REDACTOR DE LA MEMORIA T\xc9CNICA DE DISE\xd1O</b>', self.eCabecera)])
        tabla.append([self.dameTablaEspecial(['Memoria T\xe9cnica de Dise\xf1o realizada por:'], ['Instalador autorizado en baja tensi\xf3n',
          'T\xe9cnico Titulado competente'], [(0.5 * cm),
          (0.5 * cm)], datos=self.instalacion.RIngeniero)])
        tabla.append([self.dameTabla([(('Nombre y Apellidos:\n<b><font size=8.5>' + self.instalacion.Rnombre) + '</font></b>'),
          (('D.N.I.:\n<b><font size=8.5>' + self.instalacion.Rdni) + '</font></b>')], [(15 * cm),
          (4 * cm)])])
        tabla.append([self.dameTabla([(('Domicilio:\n<b><font size=8.5>' + self.instalacion.Rdomicilio) + '</font></b>'),
          (('Tel\xe9fono:\n<b><font size=8.5>' + self.instalacion.Rtelefono) + '</font></b>')], [(15 * cm),
          (4 * cm)])])
        tabla.append([self.dameTabla([(('Localidad:\n<b><font size=8.5>' + self.instalacion.Rlocalidad) + '</font></b>'),
          (('Provincia:\n<b><font size=8.5>' + self.instalacion.Rprovincia) + '</font></b>'),
          (('Correo electr\xf3nico:\n<b><font size=8.5>' + self.instalacion.Rmail) + '</font></b>'),
          (('C\xf3digo Postal:\n<b><font size=8.5>' + self.instalacion.RcodigoPostal) + '</font></b>')], [(7 * cm),
          (2.5 * cm),
          (5.5 * cm),
          (4 * cm)])])
        tabla.append([self.dameTabla([(('N\xba Carn\xe9 de Instalador/ N\xba Colegiado:\n<b><font size=8.5>' + self.instalacion.RCarne) + '</font></b>'),
          (('Categor\xeda-Especialidad/ Colegio Oficial de\n<b><font size=8.5>' + self.instalacion.RCategoria) + '</font></b>')], [(7 * cm),
          (12 * cm)])])
        t = Table(data=tabla, colWidths=[(19 * cm)], rowHeights=[(0.59999999999999998 * cm),
         (1.1000000000000001 * cm),
         (0.69999999999999996 * cm),
         (0.69999999999999996 * cm),
         (0.69999999999999996 * cm),
         (0.69999999999999996 * cm)])
        t.setStyle([('GRID',
          (0,
           0),
          (-1,
           -1),
          0.25,
          colors.black),
         ('BACKGROUND',
          (0,
           0),
          (0,
           0),
          colors.Color(0.75, 0.75, 0.75)),
         ('BOTTOMPADDING',
          (0,
           1),
          (-1,
           -1),
          0),
         ('LEFTPADDING',
          (0,
           1),
          (-1,
           -1),
          0),
         ('RIGHTPADDING',
          (0,
           1),
          (-1,
           -1),
          0),
         ('TOPPADDING',
          (0,
           1),
          (-1,
           -1),
          0),
         ('VALIGN',
          (0,
           0),
          (0,
           0),
          'CENTER'),
         ('VALIGN',
          (0,
           1),
          (-1,
           -1),
          'TOP'),
         ('ALIGN',
          (0,
           1),
          (-1,
           -1),
          'CENTER')])
        return t



    def dibujaDatosInstalacion(self):
        tabla = []
        tabla.append([Paragraph('<b>3. DATOS DE LA INSTALACI\xd3N</b>', self.eCabecera)])
        tabla.append([XPreformatted((('Emplazamiento:\n<b><font size=8.5>' + self.instalacion.IEmplazamiento) + '</font></b>'), self.eNormal)])
        tabla.append([self.dameTabla([(('Localidad:\n<b><font size=8.5>' + self.instalacion.Ilocalidad) + '</font></b>'),
          (('Provincia:\n<b><font size=8.5>' + self.instalacion.Iprovincia) + '</font></b>'),
          (('C\xf3digo Postal:\n<b><font size=8.5>' + self.instalacion.IcodigoPostal) + '</font></b>')], [(11 * cm),
          (4 * cm),
          (4 * cm)])])
        if (self.instalacion.ISuperficie == 0):
            superficie = '\n'
        else:
            superficie = str(self.instalacion.ISuperficie)
        if (self.instalacion.IOcupacion == 0):
            ocupacion = ''
        else:
            ocupacion = str(self.instalacion.IOcupacion)
        tabla.append([self.dameTabla([(('Uso al que se destina:\n<b><font size=8.5>' + self.instalacion.IUso) + '</font></b>'),
          (('Superficie(m<super>2</super>):\n<b><font size=8.5>' + superficie) + '</font></b>'),
          (('Ocupaci\xf3n(1):\n<b><font size=8.5>' + ocupacion) + '</font></b>'),
          (('Tipo de instalaci\xf3n(2)\n<b><font size=8.5>' + self.instalacion.ITipo) + '</font></b>')], [(7 * cm),
          (2 * cm),
          (2 * cm),
          (8 * cm)])])
        tabla.append([self.dameTablaEspecial(['Instalaci\xf3n'], ['Nueva',
          'Ampliaci\xf3n',
          'Modificaci\xf3n'], [(0.40000000000000002 * cm),
          (0.40000000000000002 * cm)], datos=self.instalacion.IInstalacion)])
        t = Table(data=tabla, colWidths=[(19 * cm)], rowHeights=[(0.59999999999999998 * cm),
         (0.69999999999999996 * cm),
         (0.69999999999999996 * cm),
         (0.69999999999999996 * cm),
         (0.90000000000000002 * cm)])
        t.setStyle([('GRID',
          (0,
           0),
          (-1,
           -1),
          0.25,
          colors.black),
         ('BACKGROUND',
          (0,
           0),
          (0,
           0),
          colors.Color(0.75, 0.75, 0.75)),
         ('BOTTOMPADDING',
          (0,
           1),
          (-1,
           -1),
          0),
         ('LEFTPADDING',
          (0,
           2),
          (-1,
           -1),
          0),
         ('RIGHTPADDING',
          (0,
           1),
          (-1,
           -1),
          0),
         ('TOPPADDING',
          (0,
           1),
          (-1,
           -1),
          0),
         ('VALIGN',
          (0,
           0),
          (0,
           0),
          'CENTER'),
         ('VALIGN',
          (0,
           1),
          (-1,
           -1),
          'TOP'),
         ('ALIGN',
          (0,
           1),
          (-1,
           -1),
          'CENTER')])
        return t



    def dibujaDatosPotencia(self):
        tabla = []
        tabla.append([Paragraph('<b>4. DATOS DE POTENCIA INSTALADA O PREVISTA.</b>', self.eCabecera)])
        t = Table(data=tabla, colWidths=[(19 * cm)], rowHeights=[(0.59999999999999998 * cm)])
        t.setStyle([('GRID',
          (0,
           0),
          (-1,
           -1),
          0.25,
          colors.black),
         ('BACKGROUND',
          (0,
           0),
          (0,
           0),
          colors.Color(0.75, 0.75, 0.75)),
         ('VALIGN',
          (0,
           0),
          (0,
           0),
          'CENTER')])
        return t



    def dibujaRelacionNominal(self, indice):
        tabla = []
        tabla.append([XPreformatted('<b>4.1. Relaci\xf3n nominal de receptores que se prevea instalar y su potencia en instalaciones Industriales, Agrarias, Comerciales, de\nServicio y Otras.</b>(3)', self.eCabeceraDoble)])
        tabla.append([self.dameTabla(['Uds',
          '<para align=left>Receptores de alumbrado-Descripci\xf3n</para>',
          'Potencia Total\n (kw)',
          'Uds',
          '<para align=left>Receptores de alumbrado-Descripci\xf3n</para>',
          'Potencia Total\n (kw)'], [(1 * cm),
          (6.5 * cm),
          (2 * cm),
          (1 * cm),
          (6.5 * cm),
          (2 * cm)], estilo=self.eNormalCentrado)])
        resultado1 = 0
        resultado2 = 0
        for i in range(len(self.instalacion.receptoresAlumbrado)):
            resultado1 = (resultado1 + float(self.instalacion.receptoresAlumbrado[i][2]))

        for i in range(len(self.instalacion.receptoresFuerza)):
            resultado2 = (resultado2 + float(self.instalacion.receptoresFuerza[i][2]))

        for i in range(17):
            try:
                dato1 = self.instalacion.receptoresAlumbrado[(i + indice)]
            except:
                dato1 = [' ',
                 ' ',
                 ' ']
            try:
                dato2 = self.instalacion.receptoresFuerza[(i + indice)]
            except:
                dato2 = [' ',
                 ' ',
                 ' ']
            tabla.append([self.dameTabla([dato1[0],
              dato1[1],
              dato1[2],
              dato2[0],
              dato2[1],
              dato2[2]], [(1 * cm),
              (6.5 * cm),
              (2 * cm),
              (1 * cm),
              (6.5 * cm),
              (2 * cm)], estilo=self.eLista)])

        if (resultado1 == 0):
            resultado1C = ''
        else:
            resultado1C = str(resultado1)
        if (resultado2 == 0):
            resultado2C = ''
        else:
            resultado2C = str(resultado2)
        if ((resultado1 == 0) and (resultado2 == 0)):
            resultadoC = ''
        else:
            resultadoC = str((resultado1 + resultado2))
        tabla.append([self.dameTabla(['<b>TOTAL ALUMBRADO (kw)</b>',
          (('<b>' + resultado1C) + '</b>'),
          '<b>TOTAL FUERZA (kw)</b>',
          (('<b>' + resultado2C) + '</b> ')], [(7.5 * cm),
          (2 * cm),
          (7.5 * cm),
          (2 * cm)], estilo=self.eNormalPequenio, estiloTabla=self.eTablaResultado)])
        tabla.append([self.dameTabla(['<para align=right><b>POTENCIA TOTAL A INSTALAR (kw)</b></para>',
          (('<para align=right><b>' + resultadoC) + '</b></para>')], [(16 * cm),
          (3 * cm)], estilo=self.eNormalPequenio, estiloTabla=self.eTablaResultado2)])
        t = Table(data=tabla, colWidths=[(19 * cm)], rowHeights=[(1 * cm),
         (0.59999999999999998 * cm),
         (0.34999999999999998 * cm),
         (0.34999999999999998 * cm),
         (0.34999999999999998 * cm),
         (0.34999999999999998 * cm),
         (0.34999999999999998 * cm),
         (0.34999999999999998 * cm),
         (0.34999999999999998 * cm),
         (0.34999999999999998 * cm),
         (0.34999999999999998 * cm),
         (0.34999999999999998 * cm),
         (0.34999999999999998 * cm),
         (0.34999999999999998 * cm),
         (0.34999999999999998 * cm),
         (0.34999999999999998 * cm),
         (0.34999999999999998 * cm),
         (0.34999999999999998 * cm),
         (0.34999999999999998 * cm),
         (0.40000000000000002 * cm),
         (0.40000000000000002 * cm)])
        t.setStyle([('GRID',
          (0,
           0),
          (-1,
           -1),
          0.25,
          colors.black),
         ('LINEBELOW',
          (0,
           1),
          (0,
           1),
          1,
          colors.black),
         ('LINEBELOW',
          (0,
           18),
          (0,
           18),
          1,
          colors.black),
         ('BACKGROUND',
          (0,
           0),
          (0,
           0),
          colors.Color(0.75, 0.75, 0.75)),
         ('BOTTOMPADDING',
          (0,
           1),
          (-1,
           -1),
          0),
         ('LEFTPADDING',
          (0,
           1),
          (-1,
           -1),
          0),
         ('RIGHTPADDING',
          (0,
           1),
          (-1,
           -1),
          0),
         ('TOPPADDING',
          (0,
           1),
          (-1,
           -1),
          0)])
        return t



    def dibujaPrevisionPotencia(self):
        tabla = []
        tabla.append([Paragraph('<b>4.2. Previsi\xf3n de potencia de Vivienda Unifamiliar.</b> (1)', self.eCabeceraDoble)])
        if (self.instalacion.prevision == 0):
            previsionC = ''
        else:
            previsionC = str(self.instalacion.prevision)
        tabla.append([self.dameTabla([['Electrificaci\xf3n:',
           'B\xe1sica',
           'Elevada'],
          (('Previsi\xf3n de potencia(kW):  <b><font size = 8.5>' + previsionC) + '</font></b>')], [(9.5 * cm),
          (9.5 * cm)], estilo=self.eNormalSalto, dato=self.instalacion.electrificacion)])
        tabla.append([self.dameTabla([['\xbfPosee instalaci\xf3n o preinstalaci\xf3n para tarifa nocturna?:',
           'SI',
           'NO'],
          ['\xbfPosee instalaci\xf3n o preinstalaci\xf3n para climatizaci\xf3n?:',
           'SI',
           'NO']], [(9.5 * cm),
          (9.5 * cm)], [(6.5 * cm),
          (1.5 * cm),
          (1.5 * cm)], dato=[self.instalacion.tarifaNocturna,
          self.instalacion.climatizacion])])
        t = Table(data=tabla, colWidths=[(19 * cm)], rowHeights=[(0.59999999999999998 * cm),
         (0.59999999999999998 * cm),
         (0.59999999999999998 * cm)])
        t.setStyle([('GRID',
          (0,
           0),
          (-1,
           -1),
          0.25,
          colors.black),
         ('BACKGROUND',
          (0,
           0),
          (0,
           0),
          colors.Color(0.75, 0.75, 0.75)),
         ('BOTTOMPADDING',
          (0,
           1),
          (-1,
           -1),
          0),
         ('LEFTPADDING',
          (0,
           1),
          (-1,
           -1),
          0),
         ('RIGHTPADDING',
          (0,
           1),
          (-1,
           -1),
          0),
         ('TOPPADDING',
          (0,
           1),
          (-1,
           -1),
          0),
         ('VALIGN',
          (0,
           0),
          (0,
           0),
          'CENTER'),
         ('VALIGN',
          (0,
           1),
          (-1,
           -1),
          'TOP'),
         ('ALIGN',
          (0,
           1),
          (-1,
           -1),
          'CENTER')])
        return t



    def dibujaCargaTotal(self):
        tabla = []
        tabla.append([Paragraph('<b>4.3. Carga total de Edificio destinado principalmente a Viviendas.</b> (1)', self.eCabeceraDoble)])
        elementos = []
        tabla.append([self.dameTabla(['Datos\ngenerales',
          self.dameTablaInterna1()], [(1.7 * cm),
          (17.300000000000001 * cm)], estiloTabla=self.eTablaInterna)])
        tabla.append([self.dameTabla(['Previsi\xf3n de\ncarga',
          self.dameTablaInterna2()], [(1.7 * cm),
          (17.300000000000001 * cm)], estiloTabla=self.eTablaInterna)])
        t = Table(data=tabla, colWidths=[(19 * cm)], rowHeights=[(0.59999999999999998 * cm),
         (1.7 * cm),
         (11.699999999999999 * cm)])
        t.setStyle([('BACKGROUND',
          (0,
           0),
          (0,
           0),
          colors.Color(0.75, 0.75, 0.75)),
         ('GRID',
          (0,
           0),
          (-1,
           -1),
          0.25,
          colors.black),
         ('LEFTPADDING',
          (0,
           1),
          (-1,
           -1),
          0),
         ('BOTTOMPADDING',
          (0,
           1),
          (-1,
           -1),
          0),
         ('RIGHTPADDING',
          (0,
           1),
          (-1,
           -1),
          0),
         ('TOPPADDING',
          (0,
           1),
          (-1,
           -1),
          0),
         ('VALIGN',
          (0,
           0),
          (0,
           0),
          'CENTER'),
         ('VALIGN',
          (0,
           1),
          (-1,
           -1),
          'TOP'),
         ('ALIGN',
          (0,
           1),
          (-1,
           -1),
          'CENTER'),
         ('LINEBELOW',
          (0,
           1),
          (0,
           1),
          1,
          colors.black)])
        return t



    def dameTablaInterna1(self):
        tabla = []
        if (self.instalacion.NumeroPlanta == 0):
            numeroPlantaC = ''
        else:
            numeroPlantaC = str(self.instalacion.NumeroPlanta)
        if (self.instalacion.NumeroOtros == 0):
            numeroOtrosC = ''
        else:
            numeroOtrosC = str(self.instalacion.NumeroOtros)
        tabla.append([self.dameTabla(['N\xba de plantas(incluido s\xf3tanos)',
          (('<b><font size=8.5>' + numeroPlantaC) + '</font></b>'),
          'N\xba total de otros locales(oficinas)',
          (('<b><font size=8.5>' + numeroOtrosC) + '</font></b>')], [(5.2000000000000002 * cm),
          (1.3999999999999999 * cm),
          (7.2999999999999998 * cm),
          (3.3999999999999999 * cm)], estilo=self.eNormalSalto)])
        if (self.instalacion.NumeroViviendas == 0):
            numeroViviendasC = ''
        else:
            numeroViviendasC = str(self.instalacion.NumeroViviendas)
        tabla.append([self.dameTabla(['N\xba total de viviendas',
          (('<b><font size=8.5>' + numeroViviendasC) + '</font></b>'),
          '\xbfIncluye instalaciones o preinstalaciones para climatizaci\xf3n?',
          ['',
           'SI',
           'NO']], [(5.2000000000000002 * cm),
          (1.3999999999999999 * cm),
          (7.2999999999999998 * cm),
          (3.3999999999999999 * cm)], estilo=self.eNormalSalto, dato=self.instalacion.EClimatizacion)])
        if (self.instalacion.NumeroLocales == 0):
            numeroLocalesC = ''
        else:
            numeroLocalesC = str(self.instalacion.NumeroLocales)
        tabla.append([self.dameTabla(['N\xba total de locales comerciales',
          (('<b><font size=8.5>' + numeroLocalesC) + '</font></b>'),
          '\xbfIncluye instalaciones o preinstalaciones para tarifa nocturna?',
          ['',
           'SI',
           'NO']], [(5.2000000000000002 * cm),
          (1.3999999999999999 * cm),
          (7.2999999999999998 * cm),
          (3.3999999999999999 * cm)], estilo=self.eNormalSalto, dato=self.instalacion.ETarifaNocturna)])
        t = Table(data=tabla, rowHeights=[(0.5 * cm),
         (0.59999999999999998 * cm),
         (0.59999999999999998 * cm)])
        t.setStyle([('TOPPADDING',
          (0,
           0),
          (-1,
           -1),
          0),
         ('LINEBELOW',
          (0,
           0),
          (-1,
           -1),
          0.25,
          colors.black),
         ('LEFTPADDING',
          (0,
           0),
          (-1,
           -1),
          0),
         ('BOTTOMPADDING',
          (0,
           0),
          (-1,
           -1),
          0),
         ('RIGHTPADDING',
          (0,
           0),
          (-1,
           -1),
          0),
         ('VALIGN',
          (0,
           0),
          (-1,
           -1),
          'CENTER'),
         ('ALIGN',
          (0,
           0),
          (-1,
           -1),
          'CENTER')])
        return t



    def dameTablaInterna2(self):
        tabla = []
        tabla.append([self.dameTabla(['Viviendas',
          self.dameTablaViviendas()], [(1.7 * cm),
          (15.6 * cm)], estiloTabla=self.eTablaInterna)])
        tabla.append([self.dameTabla(['Locales\ncomerciales y\noficinas',
          self.dameTablaLocales()], [(1.7 * cm),
          (15.6 * cm)], estiloTabla=self.eTablaInterna)])
        tabla.append([self.dameTabla(['Servicios\ngenerales',
          self.dameTablaServicios()], [(1.7 * cm),
          (15.6 * cm)], estiloTabla=self.eTablaInternaArriba)])
        suma = ((self.instalacion.totalPrevisionViviendas + self.instalacion.totalPrevisionLocales) + self.instalacion.totalPrevisionServicios)
        if (suma == 0):
            suma = ''
        tabla.append([self.dameTabla(['<para align=right><b>CARGA TOTAL PREVISTA DEL EDIFICIO (A+B+C) (kW)</b></para>',
          (('<para align=center><b><font size=8.5>' + str(suma)) + '</font></b></para>')], [(13.9 * cm),
          (3.3999999999999999 * cm)], estilo=self.eNormalSalto, estiloTabla=self.eTablaNormal2)])
        t = Table(data=tabla, rowHeights=[(5 * cm),
         (2.2000000000000002 * cm),
         (4 * cm),
         (0.5 * cm)])
        t.setStyle([('GRID',
          (0,
           0),
          (-1,
           -1),
          0.25,
          colors.black),
         ('TOPPADDING',
          (0,
           0),
          (-1,
           -1),
          0),
         ('BOTTOMPADDING',
          (0,
           0),
          (-1,
           -1),
          0),
         ('LEFTPADDING',
          (0,
           0),
          (-1,
           -1),
          0),
         ('RIGHTPADDING',
          (0,
           0),
          (-1,
           -1),
          0),
         ('VALIGN',
          (0,
           0),
          (-1,
           -1),
          'TOP'),
         ('LINEBELOW',
          (0,
           0),
          (0,
           0),
          1,
          colors.black),
         ('LINEBELOW',
          (0,
           1),
          (0,
           1),
          1,
          colors.black),
         ('LINEBELOW',
          (0,
           2),
          (0,
           2),
          1,
          colors.black)])
        return t



    def dameTablaViviendas(self):
        tabla = []
        tabla.append([self.dameTabla(['N\xba de viviendas\niguales',
          'Superficie\n(m<super>2</super>)',
          'Tarifa nocturna\n(2)',
          'Electrificaci\xf3n',
          'Potencia prevista por\nvivienda(kW)',
          'Totales(kW)'], [(2.2000000000000002 * cm),
          (1.5 * cm),
          (2.2000000000000002 * cm),
          (3.2000000000000002 * cm),
          (3.1000000000000001 * cm),
          (3.3999999999999999 * cm)], estilo=self.eNormalCentrado2)])
        for i in range(5):
            try:
                datos = self.instalacion.previsionViviendas[i]
                if (datos[2] == 'Si'):
                    datos[2] = 0
                else:
                    datos[2] = 1
                if (datos[3] == 'Basica'):
                    datos[3] = 0
                else:
                    datos[3] = 1
            except:
                datos = ['',
                 '',
                 '',
                 '',
                 '',
                 '']
            tabla.append([self.dameTabla([(('<b><font size=8.5>' + datos[0]) + '</font></b>'),
              (('<b><font size=8.5>' + datos[1]) + '</font></b>'),
              ['',
               'SI',
               'NO'],
              ['',
               'B\xe1sica',
               'Elevada'],
              (('<b><font size=8.5>' + datos[4]) + '</font></b>'),
              (('<b><font size=8.5>' + datos[5]) + '</font></b>')], [(2.2000000000000002 * cm),
              (1.5 * cm),
              (2.2000000000000002 * cm),
              (3.2000000000000002 * cm),
              (3.1000000000000001 * cm),
              (3.3999999999999999 * cm)], estilo=self.eNormalCentrado, estiloTabla=self.eTablaInterna2, dato=[datos[2],
              datos[3]])])
            if (datos[2] == 0):
                datos[2] = 'Si'
            if (datos[2] == 1):
                datos[2] = 'No'
            if (datos[3] == 0):
                datos[3] = 'Basica'
            if (datos[3] == 1):
                datos[3] = 'Elevada'

        resumen = self.instalacion.dameResumenViviendas()
        for i in range(len(resumen)):
            if (resumen[i] == 0):
                resumen[i] = ''
            else:
                resumen[i] = str(resumen[i])

        tabla.append([self.dameTabla(['Carga prevista en viviendas sin tarifa nocturna',
          'Carga prevista en viviendas con tarifa nocturna (2)'], [(6 * cm),
          (6.2000000000000002 * cm)], estilo=self.eNormalSalto, estiloTabla=self.eTablaSubrayada)])
        fila1 = [Paragraph('Potencia media (kW)', self.eNormalSalto),
         Paragraph((('<para align=center><b><font size = 8.5>' + resumen[3]) + '</font></b></para>'), self.eNormalSalto),
         Paragraph('Potencia media (kW)', self.eNormalSalto),
         Paragraph((('<para align=center><b><font size = 8.5>' + resumen[0]) + '</font></b></para>'), self.eNormalSalto)]
        fila2 = [Paragraph('Coeficiente simultaneidad', self.eNormalSalto),
         Paragraph((('<para align=center><b><font size = 8.5>' + resumen[4]) + '</font></b></para>'), self.eNormalSalto),
         Paragraph('Coeficiente simult. = n\xba', self.eNormalSalto),
         Paragraph((('<para align=center><b><font size = 8.5>' + resumen[1]) + '</font></b></para>'), self.eNormalSalto)]
        fila3 = [Paragraph('Total (kW)', self.eNormalSalto),
         Paragraph((('<para align=center><b><font size = 8.5>' + resumen[5]) + '</font></b></para><para align=right><b>      (a)</b></para>'), self.eNormalSalto),
         Paragraph('Total (kW)', self.eNormalSalto),
         Paragraph((('<para align=center><b><font size = 8.5>' + resumen[2]) + '</font></b></para><para align=right><b>      (b)</b></para>'), self.eNormalSalto)]
        tInterna = [fila1,
         fila2,
         fila3]
        tInterna = Table(data=tInterna, colWidths=[(3.1000000000000001 * cm),
         (2.8999999999999999 * cm),
         (3.1000000000000001 * cm),
         (3.1000000000000001 * cm)], rowHeights=[(0.40000000000000002 * cm),
         (0.40000000000000002 * cm),
         (0.40000000000000002 * cm)])
        tInterna.setStyle([('GRID',
          (0,
           0),
          (-1,
           -1),
          0.25,
          colors.black),
         ('TOPPADDING',
          (0,
           0),
          (-1,
           -1),
          0),
         ('BOTTOMPADDING',
          (0,
           0),
          (-1,
           -1),
          0),
         ('RIGHTPADDING',
          (0,
           0),
          (0,
           -1),
          0),
         ('RIGHTPADDING',
          (2,
           0),
          (2,
           -1),
          0)])
        tabla.append([tInterna])
        if (self.instalacion.totalPrevisionViviendas == 0):
            totalPrevisionViviendasC = ''
        else:
            totalPrevisionViviendasC = str(self.instalacion.totalPrevisionViviendas)
        tabla.append([self.dameTabla(['<para align=right><b>(A)</b> Carga total prevista en viviendas (kW) <b>(a+b)  </b></para>',
          (('<para align=center><b><font size=8.5>' + totalPrevisionViviendasC) + '</font></b></para>')], [(12.199999999999999 * cm),
          (3.3999999999999999 * cm)], estilo=self.eNormalSalto, estiloTabla=self.eTablaNormal2)])
        t = Table(data=tabla, rowHeights=[(0.69999999999999996 * cm),
         (0.45000000000000001 * cm),
         (0.45000000000000001 * cm),
         (0.45000000000000001 * cm),
         (0.45000000000000001 * cm),
         (0.45000000000000001 * cm),
         (0.40000000000000002 * cm),
         (1.2 * cm),
         (0.45000000000000001 * cm)])
        t.setStyle([('TOPPADDING',
          (0,
           0),
          (-1,
           -1),
          0),
         ('LINEBELOW',
          (0,
           0),
          (0,
           5),
          0.25,
          colors.black),
         ('LINEBELOW',
          (0,
           9),
          (0,
           9),
          0.25,
          colors.black),
         ('BOTTOMPADDING',
          (0,
           0),
          (-1,
           -1),
          0),
         ('LEFTPADDING',
          (0,
           0),
          (-1,
           -1),
          0),
         ('RIGHTPADDING',
          (0,
           0),
          (-1,
           -1),
          0)])
        return t



    def dameTablaLocales(self):
        tabla = []
        tabla.append([self.dameTabla(['N\xba de locales iguales',
          'Superficie (m2)',
          'Carga prevista por local (kW)',
          'Totales (kW)'], [(3.5 * cm),
          (4.0999999999999996 * cm),
          (4.5999999999999996 * cm),
          (3.3999999999999999 * cm)], estilo=self.eNormalCentrado2)])
        for i in range(3):
            try:
                datos = self.instalacion.previsionLocales[i]
            except:
                datos = ['\n',
                 '\n',
                 '\n',
                 '\n']
            tabla.append([self.dameTabla([(('<para align=center><b><font size=8.5>' + datos[0]) + '</font></b></para>'),
              (('<para align=center><b><font size=8.5>' + datos[1]) + '</font></b></para>'),
              (('<para align=center><b><font size=8.5>' + datos[2]) + '</font></b></para>'),
              (('<para align=center><b><font size=8.5>' + datos[3]) + '</font></b></para>')], [(3.5 * cm),
              (4.0999999999999996 * cm),
              (4.5999999999999996 * cm),
              (3.3999999999999999 * cm)], estiloTabla=self.eTablaInterna, estilo=self.eNormalSalto2)])
            if (self.instalacion.totalPrevisionLocales == 0):
                totalPrevisionLocalesC = ''
            else:
                totalPrevisionLocalesC = str(self.instalacion.totalPrevisionLocales)

        tabla.append([self.dameTabla(['<para align=right><b>(B)</b> Carga total prevista en locales (kW)   </para>',
          (('<para align=center><b><font size=8.5>' + totalPrevisionLocalesC) + '</font></b></para>')], [(12.199999999999999 * cm),
          (3.3999999999999999 * cm)], estilo=self.eNormalSalto, estiloTabla=self.eTablaNormal2)])
        t = Table(data=tabla, rowHeights=[(0.40000000000000002 * cm),
         (0.45000000000000001 * cm),
         (0.45000000000000001 * cm),
         (0.45000000000000001 * cm),
         (0.45000000000000001 * cm)])
        t.setStyle([('GRID',
          (0,
           0),
          (-1,
           -1),
          0.25,
          colors.black),
         ('TOPPADDING',
          (0,
           0),
          (-1,
           -1),
          0),
         ('BOTTOMPADDING',
          (0,
           0),
          (-1,
           -1),
          0),
         ('LEFTPADDING',
          (0,
           0),
          (-1,
           -1),
          0),
         ('RIGHTPADDING',
          (0,
           0),
          (-1,
           -1),
          0),
         ('VALIGN',
          (0,
           4),
          (0,
           4),
          'CENTER')])
        return t



    def dameTablaServicios(self):
        previsionServiciosGenerales = []
        for prevision in self.instalacion.previsionServiciosGenerales:
            datos = []
            for dato in prevision:
                if (dato == 0):
                    datoC = ''
                else:
                    datoC = str(dato)
                datos.append(datoC)

            previsionServiciosGenerales.append(datos)

        fila1 = [Paragraph('Servicio', self.eNormalCentrado),
         Paragraph('Unidades', self.eNormalCentrado),
         Paragraph('Superficie total (m<super>2</super>)', self.eNormalCentrado),
         Paragraph('Totales (kW)', self.eNormalCentrado)]
        fila2 = [Paragraph('Central de producci\xf3n de calor', self.eNormalSalto3),
         Paragraph((('<para align=center><b><font size=8.5>' + previsionServiciosGenerales[0][1]) + '</font></b></para>'), self.eNormalSalto3),
         Paragraph('<para align=center>----<para>', self.eNormalSalto3),
         Paragraph((('<para align=center><b><font size=8.5>' + previsionServiciosGenerales[0][3]) + '</font></b></para>'), self.eNormalSalto3)]
        fila3 = [Paragraph('Central de producci\xf3n de frio', self.eNormalSalto3),
         Paragraph((('<para align=center><b><font size=8.5>' + previsionServiciosGenerales[1][1]) + '</font></b></para>'), self.eNormalSalto3),
         Paragraph('<para align=center>----<para>', self.eNormalSalto3),
         Paragraph((('<para align=center><b><font size=8.5>' + previsionServiciosGenerales[1][3]) + '</font></b></para>'), self.eNormalSalto3)]
        fila4 = [Paragraph('Ascensores', self.eNormalSalto3),
         Paragraph((('<para align=center><b><font size=8.5>' + previsionServiciosGenerales[2][1]) + '</font></b></para>'), self.eNormalSalto3),
         Paragraph('<para align=center>----<para>', self.eNormalSalto3),
         Paragraph((('<para align=center><b><font size=8.5>' + previsionServiciosGenerales[2][3]) + '</font></b></para>'), self.eNormalSalto3)]
        fila5 = [Paragraph('Otros elevadores (montacargas,elevadores minusv\xe1lidos,etc)', self.eNormalSalto3),
         Paragraph((('<para align=center><b><font size=8.5>' + previsionServiciosGenerales[3][1]) + '</font></b></para>'), self.eNormalSalto3),
         Paragraph('<para align=center>----<para>', self.eNormalSalto3),
         Paragraph((('<para align=center><b><font size=8.5>' + previsionServiciosGenerales[3][3]) + '</font></b></para>'), self.eNormalSalto3)]
        fila6 = [Paragraph('Alumbrado portal, escaleras y espacios comunes', self.eNormalSalto3),
         Paragraph('<para align=center>----<para>', self.eNormalSalto3),
         Paragraph('<para align=center>----<para>', self.eNormalSalto3),
         Paragraph((('<para align=center><b><font size=8.5>' + previsionServiciosGenerales[4][1]) + '</font></b></para>'), self.eNormalSalto3)]
        fila7 = [Paragraph('Garaje', self.eNormalSalto3),
         Paragraph((('<para align=center><b><font size=8.5>' + previsionServiciosGenerales[5][1]) + '</font></b></para>'), self.eNormalSalto3),
         Paragraph((('<para align=center><b><font size=8.5>' + previsionServiciosGenerales[5][4]) + '</font></b></para>'), self.eNormalSalto3),
         Paragraph((('<para align=center><b><font size=8.5>' + previsionServiciosGenerales[5][3]) + '</font></b></para>'), self.eNormalSalto3)]
        fila8 = [Paragraph('Grupos de presi\xf3n', self.eNormalSalto3),
         Paragraph((('<para align=center><b><font size=8.5>' + previsionServiciosGenerales[6][1]) + '</font></b></para>'), self.eNormalSalto3),
         Paragraph('<para align=center>----<para>', self.eNormalSalto3),
         Paragraph((('<para align=center><b><font size=8.5>' + previsionServiciosGenerales[6][3]) + '</font></b></para>'), self.eNormalSalto3)]
        fila9 = [Paragraph((('Otros servicios (indicar) : <b>' + previsionServiciosGenerales[7][1]) + '</b>'), self.eNormalSalto3),
         ' ',
         ' ',
         Paragraph((('<para align=center><b><font size=8.5>' + previsionServiciosGenerales[7][2]) + '</font></b></para>'), self.eNormalSalto3)]
        tabla = [fila1,
         fila2,
         fila3,
         fila4,
         fila5,
         fila6,
         fila7,
         fila8,
         fila9]
        t = Table(data=tabla, colWidths=[(7.5999999999999996 * cm),
         (2.1000000000000001 * cm),
         (2.5 * cm),
         (3.3999999999999999 * cm)], rowHeights=[(0.40000000000000002 * cm),
         (0.40000000000000002 * cm),
         (0.40000000000000002 * cm),
         (0.40000000000000002 * cm),
         (0.40000000000000002 * cm),
         (0.40000000000000002 * cm),
         (0.40000000000000002 * cm),
         (0.40000000000000002 * cm),
         (0.40000000000000002 * cm)])
        t.setStyle([('GRID',
          (0,
           0),
          (-1,
           -1),
          0.25,
          colors.black),
         ('TOPPADDING',
          (0,
           0),
          (-1,
           -1),
          0),
         ('RIGHTPADDING',
          (0,
           0),
          (-1,
           -1),
          0)])
        if (self.instalacion.totalPrevisionServicios == 0):
            totalPrevisionServiciosC = ''
        else:
            totalPrevisionServiciosC = str(self.instalacion.totalPrevisionServicios)
        tabla = [[t],
         [self.dameTabla(['<para align=right><b>(C)</b> Carga total prevista en servicios generales (kW)   </para>',
           (('<para align=center><b><font size=8.5>' + totalPrevisionServiciosC) + '</font></b></para>')], [(12.199999999999999 * cm),
           (3.3999999999999999 * cm)], estilo=self.eNormalSalto3, estiloTabla=self.eTablaNormal2)]]
        t = Table(data=tabla, rowHeights=[(3.6000000000000001 * cm),
         (0.40000000000000002 * cm)])
        t.setStyle([('GRID',
          (0,
           0),
          (-1,
           -1),
          0.25,
          colors.black),
         ('RIGHTPADDING',
          (0,
           0),
          (-1,
           -1),
          0),
         ('BOTTOMPADDING',
          (0,
           0),
          (-1,
           -1),
          0),
         ('LEFTPADDING',
          (0,
           0),
          (-1,
           -1),
          0)])
        return t



    def dibujaAmpliaciones(self):
        tabla = []
        tabla.append([XPreformatted('<para><font size=9.5><b>4.4. Ampliaciones de potencia en edificios destinados principalmente a Viviendas.</b></font>\n<font size=7.5>    (Deberia haberse calculado previamente la carga del edificio antes de la ampliaci\xf3n seg\xfan el apartado 4.3. de esta Memoria)</font></para>', self.eCabeceraDoble)])
        tabla.append([Paragraph('Datos de las viviendas,locales y servicios generales cuya potencia se amplia', self.eNormalSalto)])
        tabla.append([self.dameTabla(['<para align=center>Identificaci\xf3n del suministro (1)</para>',
          '<para align=center>Tarifa nocturna(2)</para>',
          '<para align=center>Superficie(m<super>2</super>)</para>',
          '<para align=center>Electrificaci\xf3n</para>',
          '<para align=center>Potencias tras la ampliaci\xf3n</para>'], [(7 * cm),
          (2.5 * cm),
          (2 * cm),
          (3.5 * cm),
          (4 * cm)], estilo=self.eNormalSalto3)])
        for i in range(5):
            try:
                datos = self.instalacion.potenciaAmpliacion[i]
                if (datos[2] == 'Si'):
                    datos[2] = 0
                else:
                    datos[2] = 1
                if (datos[3] == 'B\xe1sica'):
                    datos[3] = 0
                else:
                    datos[3] = 1
            except:
                datos = ['',
                 '',
                 '',
                 '',
                 '',
                 '']
            tabla.append([self.dameTabla([(('<b><font size=8.5>' + datos[0]) + '</font></b>'),
              ['',
               'SI',
               'NO'],
              (('<b><font size=8.5>' + str(datos[1])) + '</font></b>'),
              ['',
               'B\xe1sica',
               'Elevada'],
              (('<b><font size=8.5>' + datos[4]) + '</font></b>')], [(7 * cm),
              (2.5 * cm),
              (2 * cm),
              (3.5 * cm),
              (4 * cm)], estilo=self.eNormalCentrado, estiloTabla=self.eTablaInterna2, dato=[datos[2],
              datos[3]])])
            if (datos[2] == 0):
                datos[2] = 'Si'
            if (datos[2] == 1):
                datos[2] = 'No'
            if (datos[3] == 0):
                datos[3] = 'B\xe1sica'
            if (datos[3] == 1):
                datos[3] = 'Elevada'

        tabla.append([Paragraph('Previsi\xf3n de carga del edificio tras la ampliaci\xf3n (kW)', self.eNormalSalto)])
        tabla.append([self.dameTabla(['Nueva previsi\xf3n de cargas',
          self.dameTablaInterna3(),
          self.dameTablaInterna4()], [(3 * cm),
          (7 * cm),
          (9 * cm)], estiloTabla=self.eTablaInterna)])
        tabla.append([self.dameTablaInterna5()])
        t = Table(data=tabla, colWidths=[(19 * cm)], rowHeights=[(0.90000000000000002 * cm),
         (0.40000000000000002 * cm),
         (0.40000000000000002 * cm),
         (0.40000000000000002 * cm),
         (0.40000000000000002 * cm),
         (0.40000000000000002 * cm),
         (0.40000000000000002 * cm),
         (0.40000000000000002 * cm),
         (0.40000000000000002 * cm),
         (1.6000000000000001 * cm),
         (1.5 * cm)])
        t.setStyle([('GRID',
          (0,
           0),
          (-1,
           -1),
          0.25,
          colors.black),
         ('LINEBELOW',
          (0,
           1),
          (0,
           1),
          1,
          colors.black),
         ('LINEBELOW',
          (0,
           7),
          (0,
           7),
          1,
          colors.black),
         ('BACKGROUND',
          (0,
           0),
          (0,
           0),
          colors.Color(0.75, 0.75, 0.75)),
         ('BOTTOMPADDING',
          (0,
           1),
          (-1,
           -1),
          0),
         ('LEFTPADDING',
          (0,
           2),
          (0,
           7),
          0),
         ('LEFTPADDING',
          (0,
           9),
          (-1,
           -1),
          0),
         ('RIGHTPADDING',
          (0,
           1),
          (-1,
           -1),
          0),
         ('TOPPADDING',
          (0,
           1),
          (-1,
           -1),
          0)])
        return t



    def dameTablaInterna3(self):
        if (self.instalacion.viviendasSin == 0):
            viviendasSinC = ''
        else:
            viviendasSinC = str(self.instalacion.viviendasSin)
        fila1 = [Paragraph('Viviendas sin tarifa nocturna (kW)', self.eNormalSalto),
         Paragraph((('<b><font size=8.5>' + viviendasSinC) + '</font></b>'), self.eNormalCentrado3)]
        if (self.instalacion.viviendasCon == 0):
            viviendasConC = ''
        else:
            viviendasConC = str(self.instalacion.viviendasCon)
        fila2 = [Paragraph('Viviendas con tarifa nocturna (kW)', self.eNormalSalto),
         Paragraph((('<b><font size=8.5>' + viviendasConC) + '</font></b>'), self.eNormalCentrado3)]
        if (self.instalacion.locales == 0):
            localesC = ''
        else:
            localesC = str(self.instalacion.locales)
        fila3 = [Paragraph('Locales comerciales y oficinas (kW)', self.eNormalSalto),
         Paragraph((('<b><font size=8.5>' + localesC) + '</font></b>'), self.eNormalCentrado3)]
        if (self.instalacion.servicios == 0):
            serviciosC = ''
        else:
            serviciosC = str(self.instalacion.servicios)
        fila4 = [Paragraph('Servicios Generales (kW)', self.eNormalSalto),
         Paragraph((('<b><font size=8.5>' + serviciosC) + '</font></b>'), self.eNormalCentrado3)]
        tabla = [fila1,
         fila2,
         fila3,
         fila4]
        t = Table(data=tabla, colWidths=[(4.0999999999999996 * cm),
         (2.8999999999999999 * cm)], rowHeights=[(0.40000000000000002 * cm),
         (0.40000000000000002 * cm),
         (0.40000000000000002 * cm),
         (0.40000000000000002 * cm)])
        t.setStyle([('GRID',
          (0,
           0),
          (-1,
           -1),
          0.25,
          colors.black),
         ('TOPPADDING',
          (0,
           0),
          (-1,
           -1),
          0),
         ('BOTTOMPADDING',
          (0,
           0),
          (-1,
           -1),
          0),
         ('RIGHTPADDING',
          (0,
           0),
          (-1,
           -1),
          0)])
        return t



    def dameTablaInterna4(self):
        tablakw = []
        suma = (((self.instalacion.viviendasSin + self.instalacion.viviendasCon) + self.instalacion.locales) + self.instalacion.servicios)
        if (suma == 0):
            suma = ''
        tablakw.append([Paragraph((('<para align=right><b><font size=8.5>' + str(suma)) + '        </font></b>(KW)</para>'), self.eNormal)])
        tablakw = Table(data=tablakw)
        tablakw.setStyle([('GRID',
          (0,
           0),
          (-1,
           -1),
          0.25,
          colors.black)])
        tabla = []
        tabla.append([Paragraph('Nueva previsi\xf3n total de carga del edificio', self.eNormalSalto),
         tablakw])
        t = Table(data=tabla, colWidths=[(3 * cm),
         (6 * cm)])
        t.setStyle([('VALIGN',
          (0,
           0),
          (-1,
           -1),
          'CENTER')])
        return t



    def dameTablaInterna5(self):
        tabla = []
        tabla.append([Paragraph('Modificaciones en instalaciones debidas a las aplicaciones', self.eNormalSalto)])
        tabla.append([self.dameListaIndicadoresTablaInterna5()])
        t = Table(data=tabla, rowHeights=[(0.40000000000000002 * cm),
         (1.2 * cm)])
        t.setStyle([('VALIGN',
          (0,
           0),
          (0,
           0),
          'CENTER')])
        return t



    def dameListaIndicadoresTablaInterna5(self):
        tabla = []
        dato = []
        for elemento in self.instalacion.listaCheck:
            if elemento:
                dato.append(1)
            else:
                dato.append(None)

        tabla.append([self.dameCadenaConSelector('Ninguna', seleccionado=dato[0]),
         self.dameCadenaConSelector('Caja general de protecci\xf3n', seleccionado=dato[1]),
         self.dameCadenaConSelector('Linea general de alimentaci\xf3n', seleccionado=dato[2]),
         self.dameCadenaConSelector('Instalaciones interiores', seleccionado=dato[3])])
        tabla.append([self.dameCadenaConSelector('Interruptor general de maniobras', seleccionado=dato[4]),
         self.dameCadenaConSelector('Cajas de Derivaci\xf3n', seleccionado=dato[5]),
         self.dameCadenaConSelector('Emplazamientos de contadores', seleccionado=dato[6]),
         ''])
        tabla.append([self.dameCadenaConSelector('Fusibles de seguridad', seleccionado=dato[7]),
         self.dameCadenaConSelector('Contadores', seleccionado=dato[8]),
         self.dameCadenaConSelector('Derivaciones individuales', seleccionado=dato[9]),
         ''])
        t = Table(data=tabla, rowHeights=[(0.40000000000000002 * cm),
         (0.40000000000000002 * cm),
         (0.40000000000000002 * cm)])
        return t



    def dibujaMemoriaDescriptiva(self):
        tabla = []
        tabla.append([Paragraph('<b>5. MEMORIA DESCRIPTIVA DE LA INSTALACI\xd3N</b>', self.eCabecera)])
        tabla.append([Paragraph('<b>Punto de suministro</b>', self.eNormalSalto)])
        tabla.append([self.dameTabla(['Empresa distribuidora',
          'Punto de conexion (3)',
          'Intensidad del cortocircuito (4)(kA)'], [(11.5 * cm),
          (3 * cm),
          (4.5 * cm)], estilo=self.eNormalSalto4, estiloTabla=self.eTablaInterna3)])
        if ((self.instalacion.intensidadCC == 0) and ((self.instalacion.empresa == '') and (self.instalacion.puntoConexion == ''))):
            intensidadCCC = '\n'
        elif (self.instalacion.intensidadCC == 0):
            intensidadCCC = ''
        else:
            intensidadCCC = str(self.instalacion.intensidadCC)
        tabla.append([self.dameTabla([(('<b><font size=8.5>' + self.instalacion.empresa) + '</b></font>'),
          (('<b><font size=8.5>' + self.instalacion.puntoConexion[:6]) + '</b></font>'),
          (('<b><font size=8.5>' + intensidadCCC) + '</b></font>')], [(11.5 * cm),
          (3 * cm),
          (4.5 * cm)])])
        tabla.append([Paragraph('<b>Caracteristicas generales de la instalaci\xf3n</b>', self.eNormalSalto)])
        if (self.instalacion.potenciaInstalada == 0):
            potenciaInstaladaC = '\n'
        else:
            potenciaInstaladaC = str(self.instalacion.potenciaInstalada)
        tabla.append([self.dameTabla([['Tipo de suministro',
           'Monof\xe1sico',
           'Trif\xe1sico'],
          (('Tensi\xf3n de suminstro (5)(V): <b><font size=8.5>' + self.instalacion.tensionSuministro) + '</font></b>'),
          (('Potencia instalada o prevista(kW): <b><font size=8.5>' + potenciaInstaladaC) + '</font></b>')], [(8 * cm),
          (5.5 * cm),
          (5.5 * cm)], estilo=self.eNormalSalto, estiloTabla=self.eTablaInterna, dato=self.instalacion.tipoSuministro)])
        if (self.instalacion.inBase1 == 0):
            inBase1C = ''
        else:
            inBase1C = str(self.instalacion.inBase1)
        if (self.instalacion.inFusible1 == 0):
            inFusible1C = ''
        else:
            inFusible1C = str(self.instalacion.inFusible1)
        if (self.instalacion.inPotencia1 == 0):
            inPotencia1C = ''
        else:
            inPotencia1C = str(self.instalacion.inPotencia1)
        tabla.append([XPreformatted((((((('<b>Caja General de Protecci\xf3n 1:</b>               I<sub>N</sub> bases (A) <b><font size=7.5>' + inBase1C) + '</font></b>                  I<sub>N</sub>del fusible (A) <b><font size=7.5>') + inFusible1C) + '</font></b>             Poder del corte del fusible (kA) <b><font size=7.5>') + inPotencia1C) + '</font></b>'), self.eNormalSalto)])
        if (self.instalacion.inBase2 == 0):
            inBase2C = ''
        else:
            inBase2C = str(self.instalacion.inBase2)
        if (self.instalacion.inFusible2 == 0):
            inFusible2C = ''
        else:
            inFusible2C = str(self.instalacion.inFusible2)
        if (self.instalacion.inPotencia2 == 0):
            inPotencia2C = ''
        else:
            inPotencia2C = str(self.instalacion.inPotencia2)
        tabla.append([XPreformatted((((((('<b>Caja General de Protecci\xf3n 2:</b>               I<sub>N</sub> bases (A) <b><font size=7.5>' + inBase2C) + '</font></b>                  I<sub>N</sub>del fusible (A) <b><font size=7.5>') + inFusible2C) + '</font></b>             Poder del corte del fusible (kA) <b><font size=7.5>') + inPotencia2C) + '</font></b>'), self.eNormalSalto)])
        tabla.append([Paragraph('<b>L\xednea General de Alimentaci\xf3n 1</b>', self.eNormalSalto)])
        tabla.append([self.dameTabla(['Tipo de instalaci\xf3n (6)',
          'Conductor',
          'Secci\xf3n fase/neutro',
          'Material de aislamiento'], [(12 * cm),
          (1.5 * cm),
          (2.5 * cm),
          (3 * cm)], estilo=self.eNormalSalto3, estiloTabla=self.eTablaInterna2)])
        datos = self.dameDatosLGA()
        tabla.append([self.dameTabla([(('<b>' + datos[0][0]) + '</b>'),
          (('<b>' + datos[0][1]) + '</b>'),
          (('<b>' + datos[0][2]) + '</b><para align=right>(mm<super>2</super>)<para>'),
          (('<b>' + datos[0][3]) + '</b>')], [(12 * cm),
          (1.5 * cm),
          (2.5 * cm),
          (3 * cm)], estilo=self.eNormalSalto, estiloTabla=self.eTablaInterna2)])
        tabla.append([Paragraph('<b>L\xednea General de Alimentaci\xf3n 2</b>', self.eNormalSalto)])
        tabla.append([self.dameTabla(['Tipo de instalaci\xf3n (6)',
          'Conductor',
          'Secci\xf3n fase/neutro',
          'Material de aislamiento'], [(12 * cm),
          (1.5 * cm),
          (2.5 * cm),
          (3 * cm)], estilo=self.eNormalSalto3, estiloTabla=self.eTablaInterna2)])
        tabla.append([self.dameTabla([datos[1][0],
          datos[1][1],
          (datos[1][2] + '<para align=right>(mm<super>2</super>)<para>'),
          datos[1][3]], [(12 * cm),
          (1.5 * cm),
          (2.5 * cm),
          (3 * cm)], estilo=self.eNormalSalto, estiloTabla=self.eTablaInterna2)])
        tabla.append([Paragraph('<b>Derivaci\xf3n individual (7)</b>', self.eNormalSalto)])
        tabla.append([self.dameTabla(['Tipo de instalaci\xf3n (6)',
          '<para align=center>Conductor</para>',
          '<para align=center>Tensi\xf3n asignada\n(V)</para>',
          '<para align=center>Secci\xf3n fase/neut/CP\n(mm<super>2</super>)</para>',
          '<para align=center>Mat. aislamiento</para>',
          '<para align=center>I<sub>N</sub> fusible\n(9)(8)(A)</para>'], [(9 * cm),
          (1.5 * cm),
          (2 * cm),
          (2.5 * cm),
          (2 * cm),
          (2 * cm)], estilo=self.eNormalSalto3, estiloTabla=self.eTablaInterna)])
        datosDI = self.dameDatosDI()
        tabla.append([self.dameTabla([(('<b>' + datosDI[0]) + '</b>'),
          (('<b>' + datosDI[1]) + '</b>'),
          (('<b>' + datosDI[2]) + '</b>'),
          (('<b>' + datosDI[3]) + '</b>'),
          (('<b>' + datosDI[4]) + '</b>'),
          (('<b>' + datos[0][4]) + '</b>')], [(9 * cm),
          (1.5 * cm),
          (2 * cm),
          (2.5 * cm),
          (2 * cm),
          (2 * cm)])])
        tabla.append([Paragraph('<b>Contadores</b>', self.eNormalSalto)])
        if (self.instalacion.interruptorGeneral == 0):
            interruptorGeneralC = ''
        else:
            interruptorGeneralC = str(self.instalacion.interruptorGeneral)
        tabla.append([self.dameTabla([self.dameTablaSinCeldas(['Instalaci\xf3n',
           'Individual',
           'Concentrada en un solo lugar',
           'Concentraci\xf3n en varios lugares'], [(2 * cm),
           (0.5 * cm),
           (1.5 * cm),
           (0.5 * cm),
           (3.5 * cm),
           (0.5 * cm),
           (3.5 * cm)], seleccionado=self.instalacion.contadorInstalacion),
          (('\t    Interruptor general de corte (9)(A): <b><font size=8.5>' + interruptorGeneralC) + '</font></b>')], [(12.5 * cm),
          (6.5 * cm)], estilo=self.eNormalSalto, estiloTabla=self.eTablaInterna)])
        tabla.append([self.dibujaCuadrado()])
        tabla.append([Paragraph('<b>Sistema empleado para la protecci\xf3n contra contactos indirectos</b> (11):', self.eNormalSalto)])
        tabla.append([Paragraph('<b>Puesta a Tierra:</b>', self.eNormalSalto)])
        if (self.instalacion.resistenciaCalculada == 0):
            resistenciaCalculadaC = ''
        else:
            resistenciaCalculadaC = str(self.instalacion.resistenciaCalculada)
        tabla.append([self.dameTabla([(('Tomas de tierra (12)\n<b><font size=8.5>' + self.instalacion.tomaTierra) + '</font></b>'),
          (('Conductores de tierra (13)\n<b><font size=8.5>' + self.instalacion.conductores) + '</font></b>'),
          (('Resistencia calculada (&#937;)\n<b><font size=8.5>' + resistenciaCalculadaC) + '</font></b>')], estilo=self.eNormalSalto3)])
        t = Table(data=tabla, colWidths=[(19 * cm)], rowHeights=[(0.59999999999999998 * cm),
         (0.40000000000000002 * cm),
         (0.29999999999999999 * cm),
         (0.40000000000000002 * cm),
         (0.29999999999999999 * cm),
         (0.5 * cm),
         (0.40000000000000002 * cm),
         (0.40000000000000002 * cm),
         (0.29999999999999999 * cm),
         (0.29999999999999999 * cm),
         (0.40000000000000002 * cm),
         (0.29999999999999999 * cm),
         (0.29999999999999999 * cm),
         (0.40000000000000002 * cm),
         (0.29999999999999999 * cm),
         (0.59999999999999998 * cm),
         (0.40000000000000002 * cm),
         (0.40000000000000002 * cm),
         (0.40000000000000002 * cm),
         (2.2000000000000002 * cm),
         (0.40000000000000002 * cm),
         (0.29999999999999999 * cm),
         (0.69999999999999996 * cm)])
        t.setStyle([('GRID',
          (0,
           0),
          (-1,
           -1),
          0.25,
          colors.black),
         ('BACKGROUND',
          (0,
           0),
          (0,
           0),
          colors.Color(0.75, 0.75, 0.75)),
         ('BOTTOMPADDING',
          (0,
           1),
          (-1,
           -1),
          0),
         ('LEFTPADDING',
          (0,
           2),
          (0,
           2),
          0),
         ('LEFTPADDING',
          (0,
           3),
          (0,
           3),
          0),
         ('LEFTPADDING',
          (0,
           5),
          (0,
           5),
          0),
         ('LEFTPADDING',
          (0,
           9),
          (0,
           9),
          0),
         ('LEFTPADDING',
          (0,
           10),
          (0,
           10),
          0),
         ('LEFTPADDING',
          (0,
           12),
          (0,
           12),
          0),
         ('LEFTPADDING',
          (0,
           13),
          (0,
           13),
          0),
         ('LEFTPADDING',
          (0,
           15),
          (0,
           15),
          0),
         ('LEFTPADDING',
          (0,
           16),
          (0,
           16),
          0),
         ('LEFTPADDING',
          (0,
           18),
          (0,
           18),
          0),
         ('LEFTPADDING',
          (0,
           19),
          (0,
           19),
          0),
         ('LEFTPADDING',
          (0,
           22),
          (0,
           22),
          0),
         ('RIGHTPADDING',
          (0,
           1),
          (-1,
           -1),
          0),
         ('TOPPADDING',
          (0,
           1),
          (-1,
           -1),
          0),
         ('VALIGN',
          (0,
           0),
          (0,
           0),
          'CENTER'),
         ('LINEBELOW',
          (0,
           3),
          (0,
           3),
          1,
          colors.black),
         ('LINEBELOW',
          (0,
           5),
          (0,
           5),
          1,
          colors.black),
         ('LINEBELOW',
          (0,
           6),
          (0,
           6),
          1,
          colors.black),
         ('LINEBELOW',
          (0,
           7),
          (0,
           7),
          1,
          colors.black),
         ('LINEBELOW',
          (0,
           10),
          (0,
           10),
          1,
          colors.black),
         ('LINEBELOW',
          (0,
           13),
          (0,
           13),
          1,
          colors.black),
         ('LINEBELOW',
          (0,
           16),
          (0,
           16),
          1,
          colors.black),
         ('LINEBELOW',
          (0,
           18),
          (0,
           18),
          1,
          colors.black),
         ('LINEBELOW',
          (0,
           19),
          (0,
           19),
          1,
          colors.black)])
        return t



    def dameDatosLGA(self):
        dato = self.instalacion.dameDatosLGA()
        while (len(dato) < 2):
            dato.append(['',
             '',
             '',
             '',
             ''])

        return dato



    def dameDatosDI(self):
        dato = self.instalacion.dameDatosDI()
        if (dato == 0):
            dato = ['\n',
             '\n',
             '',
             '',
             '\n',
             '\n']
        return dato



    def dibujaCuadrado(self):
        tabla = []
        tabla.append([self.dibujaTablaCuadroGeneral(),
         self.dibujaTablaProteccionContra9()])
        tabla.append([self.dibujaTablaProteccionesDiferenciales(),
         self.dibujaTablaProteccionContra10()])
        t = Table(data=tabla, colWidths=[(9.5 * cm),
         (9.5 * cm)], rowHeights=[(1.1000000000000001 * cm),
         (1.1000000000000001 * cm)])
        t.setStyle([('GRID',
          (0,
           0),
          (-1,
           -1),
          0.25,
          colors.black),
         ('BOTTOMPADDING',
          (0,
           0),
          (-1,
           -1),
          0),
         ('RIGHTPADDING',
          (0,
           0),
          (-1,
           -1),
          0),
         ('LEFTPADDING',
          (0,
           0),
          (-1,
           -1),
          0),
         ('VALIGN',
          (0,
           1),
          (0,
           1),
          'CENTER')])
        return t



    def dibujaTablaCuadroGeneral(self):
        tabla = []
        tabla.append([Paragraph('<b>Cuadro General de Protecci\xf3n:</b>', self.eNormalSalto)])
        tabla.append([XPreformatted('<para>           Interruptor general de corte</para>', self.eNormalSalto)])
        intensidad = self.dameIntensidadInterruptor()
        if (self.instalacion.poderCorte == 0):
            poderCorteC = ''
        else:
            poderCorteC = str(self.instalacion.poderCorte)
        tabla.append([XPreformatted((((('<para>                                  I<sub>N</sub>(A): <b>' + intensidad) + '</b>             Poder de corte (KA): <b> ') + poderCorteC) + '</b></para>'), self.eNormalSalto)])
        t = Table(data=tabla)
        t.setStyle(self.eTablaInterna)
        return t



    def dameIntensidadInterruptor(self):
        if self.instalacion.compruebaProyecto():
            if (self.instalacion.interruptorDI == 0):
                return ''
            else:
                return str(self.instalacion.interruptorDI)
        return self.instalacion.dameInterruptorDI()



    def dibujaTablaProteccionContra9(self):
        tabla = []
        tabla.append([Paragraph('<b>Protecci\xf3n contra Sobretensiones instaladas<b> (9)(10):', self.eNormalSalto)])
        tabla.append([self.dameTabla([(('<b><font size=8.5>' + self.instalacion.proteccionSobreTensiones) + '</b></font>'),
          (('Categoria <b><font size=8.5>' + self.instalacion.proteccionCategoria) + '</b></font>')], [(6.5 * cm),
          (2.7799999999999998 * cm)], estilo=self.eNormalSalto)])
        t = Table(data=tabla)
        return t



    def dibujaTablaProteccionesDiferenciales(self):
        sensibilidad = self.dameSensibilidad()
        tabla = []
        tabla.append([Paragraph('<b>Protecciones Diferenciales a instalar </b>(10):', self.eNormalSalto2)])
        tabla.append([self.dameTablaSinCeldas(['Sensibilidad (mA):',
          '10',
          '30',
          '300',
          (('Otras: <b><font size = 8.5>' + sensibilidad[4]) + '</font></b>')], [(2.5 * cm),
          (0.5 * cm),
          (0.5 * cm),
          (0.5 * cm),
          (0.5 * cm),
          (0.5 * cm),
          (0.5 * cm),
          (0.5 * cm),
          (3 * cm)], seleccionado=sensibilidad)])
        t = Table(data=tabla)
        t.setStyle(self.eTablaInterna)
        return t



    def dameSensibilidad(self):
        solucion = [0,
         0,
         0,
         0,
         '']
        if self.instalacion.compruebaProyecto():
            for i in range(len(self.instalacion.sensibilidadesProyecto)):
                solucion[i] = self.instalacion.sensibilidadesProyecto[i]

            solucion[4] = self.instalacion.otraSensibilidad
            return solucion
        return self.instalacion.dameSensibilidad()



    def dibujaTablaProteccionContra10(self):
        tabla = []
        tabla.append([Paragraph('<b>Protecciones contra Sobreintensidades instaladas<b> (10):', self.eNormalSalto5)])
        tabla.append([self.dameTablaSinCeldas(['',
          'Interrup. Automaticos de protecci\xf3n contra sobrecargas y cortocircuitos',
          'Fusibles calibrados de protecci\xf3n contra sobrecargas y cortocircuitos'], [(0 * cm),
          (0.5 * cm),
          (4.5 * cm),
          (0.5 * cm),
          (4 * cm)], seleccionado=[self.instalacion.checkInterruptor,
          self.instalacion.checkFusible])])
        t = Table(data=tabla)
        t.setStyle([('VALIGN',
          (0,
           0),
          (0,
           0),
          'BOTTOM')])
        return t



    def parteEnCachos(self, tocho, ancho):
        cadena = ''
        lineas = []
        for palabra in tocho.split():
            cadena += palabra
            if (self.tamanio(cadena) > ancho):
                lineas.append((cadena + '\n'))
                cadena = ''
            else:
                cadena += ' '

        lineas.append((cadena + '\n'))
        return lineas



    def dameCadenaConLineas(self, c, ancho):
        cadena = ''
        lineas = c.split('\n')
        for linea in lineas:
            if (self.tamanio(linea) > ancho):
                for i in self.parteEnCachos(linea, ancho):
                    cadena += i

            else:
                cadena += (linea + '\n')

        return cadena



    def tamanio(self, cadena):
        numero = 0
        for i in cadena:
            if i.isupper():
                numero += 1.6000000000000001
            else:
                numero += 1

        return numero



    def dibujaAclaraciones(self):
        celda = []
        cadena = self.dameCadenaConLineas(self.instalacion.aclaracion, 120)
        celda.append([XPreformatted(cadena, self.eNormalTexto)])
        celda.append([XPreformatted('(1) Este apartado est\xe1 reservado para que el redactor de la Memoria pueda realizar todas las aclaraciones que estime oportunas de la instalacion el\xe9ctrica\npara baja tensi\xf3n objeto de la misma, asi como ampliar y/o aclarar los puntos y apartados que forman parte la presente Memoria T\xe9cnica de Dise\xf1o\n(2) Podr\xe1n utilizarse tantas hojas de aclaraciones como estime necesarias el redactor de la presente Memoria T\xe9cnica de Dise\xf1o', self.eNotas)])
        tCelda = Table(data=celda, colWidths=[(19 * cm)], rowHeights=[(22.5 * cm),
         (1.5 * cm)])
        tCelda.setStyle([('VALIGN',
          (0,
           0),
          (0,
           0),
          'TOP'),
         ('RIGHTPADDING',
          (0,
           0),
          (0,
           0),
          1),
         ('LINEBELOW',
          (0,
           0),
          (0,
           0),
          0.25,
          colors.black)])
        tabla = []
        tabla.append([XPreformatted('<para><font size=9.5><b>6. ACLARACIONES A LA MEMORIA.</b></font><font size=7.5>(1)(2)</font></para>', self.eNormal)])
        tabla.append([tCelda])
        t = Table(data=tabla, colWidths=[(19 * cm)], rowHeights=[(0.59999999999999998 * cm),
         (24 * cm)])
        t.setStyle([('GRID',
          (0,
           0),
          (-1,
           -1),
          0.25,
          colors.black),
         ('BACKGROUND',
          (0,
           0),
          (0,
           0),
          colors.Color(0.75, 0.75, 0.75)),
         ('VALIGN',
          (0,
           0),
          (0,
           0),
          'CENTER')])
        return t



    def dibujaTablaCalculosJustificativos(self, hoja = None, indice = None):
        tabla = []
        tabla.append([XPreformatted('<para><font size=9.5><b>7. CALCULOS JUSTIFICATIVOS DE LAS CARACTERISTICAS DE LA L\xcdNEA GENERAL DE ALIMENTACI\xd3N, DERIVACIONES INDIVIDUALES Y L\xcdNEAS\nSECUNDARIAS, SUS ELEMENTOS DE PROTECCI\xd3N Y SUS PUNTOS DE UTILIZACI\xd3N.</b></font><font size=7.5>(1)</font></para>', self.eNormal)])
        tabla.append([self.dameTablaDatos(hoja, indice)])
        if hoja:
            tabla.append([XPreformatted(('Observaciones:\n' + hoja.observaciones), self.eNormal)])
        else:
            tabla.append([XPreformatted('Observaciones:', self.eNormal)])
        t = Table(data=tabla, colWidths=[(25.699999999999999 * cm)], rowHeights=[(1 * cm),
         (7.5999999999999996 * cm),
         (2 * cm)])
        t.setStyle([('GRID',
          (0,
           0),
          (-1,
           -1),
          0.25,
          colors.black),
         ('BACKGROUND',
          (0,
           0),
          (0,
           0),
          colors.Color(0.75, 0.75, 0.75)),
         ('VALIGN',
          (0,
           0),
          (0,
           0),
          'CENTER'),
         ('VALIGN',
          (0,
           2),
          (0,
           2),
          'TOP'),
         ('TOPPADDING',
          (0,
           1),
          (-1,
           -1),
          0),
         ('BOTTOMPADDING',
          (0,
           1),
          (-1,
           -1),
          0),
         ('RIGHTPADDING',
          (0,
           1),
          (-1,
           -1),
          0),
         ('LEFTPADDING',
          (0,
           1),
          (-1,
           -1),
          0)])
        return t



    def dameTablaDatos(self, hoja = None, indice = None):
        tabla = []
        fila1 = [XPreformatted('Denominaci\xf3n\nde la L\xednea (2)', self.eNormalSaltoCentrado),
         XPreformatted('II/III\n(3)', self.eNormalSaltoCentrado),
         XPreformatted('Tensi\xf3n\n(V)', self.eNormalSaltoCentrado),
         XPreformatted('Potencia\n(w)', self.eNormalSaltoCentrado),
         XPreformatted('Coef. de\nC\xe1lc. (4)', self.eNormalSaltoCentrado),
         XPreformatted('Potencia de\n c\xe1lculo (W.)', self.eNormalSaltoCentrado),
         XPreformatted('Longitud\n(m)', self.eNormalSaltoCentrado),
         XPreformatted('Intensidad\n(A)', self.eNormalSaltoCentrado),
         XPreformatted('Secci\xf3n (mm<super>2</super>)/\n Cu/Al/Al-Ac(5)', self.eNormalSaltoCentrado),
         XPreformatted('C. d. T.\n (%)', self.eNormalSaltoCentrado),
         XPreformatted('C. d. T.\n Adm (%)', self.eNormalSaltoCentrado),
         XPreformatted('Densidad\n (A/mm<super>2</super>)', self.eNormalSaltoCentrado),
         XPreformatted('Canalizaci\xf3n\n (5)', self.eNormalSaltoCentrado),
         XPreformatted('Prot. Sobre\n (A)', self.eNormalSaltoCentrado),
         XPreformatted('Prot. Dif\n (mA)', self.eNormalSaltoCentrado)]
        tablaF = [fila1]
        for i in range(22):
            try:
                fila = hoja.datosCircuitos[(i + indice)].dameListaResumen()
            except:
                fila = ['',
                 '',
                 '',
                 '',
                 '',
                 '',
                 '',
                 '',
                 '',
                 '',
                 '',
                 '',
                 '',
                 '',
                 '']
            for j in range(len(fila)):
                fila[j] = str(fila[j])

            if (fila[1] == 'II - Monof\xe1sico'):
                fila[1] = 'II'
            elif (fila[1] == 'III - Trif\xe1sico'):
                fila[1] = 'III'
            else:
                fila[1] = fila[1]
            dato = [XPreformatted(fila[0], self.eNormalSaltoCentrado2),
             XPreformatted(fila[1], self.eNormalSaltoCentrado2),
             XPreformatted(fila[2], self.eNormalSaltoCentrado2),
             XPreformatted(fila[3], self.eNormalSaltoCentrado2),
             XPreformatted(fila[4], self.eNormalSaltoCentrado2),
             XPreformatted(fila[5], self.eNormalSaltoCentrado2),
             XPreformatted(fila[6], self.eNormalSaltoCentrado2),
             XPreformatted(fila[7], self.eNormalSaltoCentrado2),
             XPreformatted(fila[8], self.eNormalSaltoCentrado2),
             XPreformatted(fila[9], self.eNormalSaltoCentrado2),
             XPreformatted(fila[10], self.eNormalSaltoCentrado2),
             XPreformatted(fila[11], self.eNormalSaltoCentrado2),
             XPreformatted(fila[12], self.eNormalSaltoCentrado2),
             XPreformatted(fila[13], self.eNormalSaltoCentrado2),
             XPreformatted(fila[14], self.eNormalSaltoCentrado2)]
            tablaF.append(dato)
            if (fila[1] == 'II'):
                fila[1] = 'II - Monof\xe1sico'
            elif (fila[1] == 'III'):
                fila[1] = 'III - Trif\xe1sico'
            else:
                fila[1] = fila[1]

        tabla = Table(data=tablaF, colWidths=[(2 * cm),
         (1.2 * cm),
         (1.2 * cm),
         (1.5 * cm),
         (1.2 * cm),
         (1.8 * cm),
         (1.5 * cm),
         (1.5 * cm),
         (2.2000000000000002 * cm),
         (1.2 * cm),
         (1.5 * cm),
         (1.5 * cm),
         (4 * cm),
         (1.7 * cm),
         (1.7 * cm)], rowHeights=[(1 * cm),
         (0.29999999999999999 * cm),
         (0.29999999999999999 * cm),
         (0.29999999999999999 * cm),
         (0.29999999999999999 * cm),
         (0.29999999999999999 * cm),
         (0.29999999999999999 * cm),
         (0.29999999999999999 * cm),
         (0.29999999999999999 * cm),
         (0.29999999999999999 * cm),
         (0.29999999999999999 * cm),
         (0.29999999999999999 * cm),
         (0.29999999999999999 * cm),
         (0.29999999999999999 * cm),
         (0.29999999999999999 * cm),
         (0.29999999999999999 * cm),
         (0.29999999999999999 * cm),
         (0.29999999999999999 * cm),
         (0.29999999999999999 * cm),
         (0.29999999999999999 * cm),
         (0.29999999999999999 * cm),
         (0.29999999999999999 * cm),
         (0.29999999999999999 * cm)])
        tabla.setStyle([('GRID',
          (0,
           0),
          (-1,
           -1),
          0.25,
          colors.black),
         ('TOPPADDING',
          (0,
           0),
          (-1,
           -1),
          0),
         ('BOTTOMPADDING',
          (0,
           0),
          (-1,
           -1),
          0),
         ('RIGHTPADDING',
          (0,
           0),
          (-1,
           -1),
          0),
         ('LEFTPADDING',
          (0,
           0),
          (-1,
           -1),
          0),
         ('VALIGN',
          (0,
           0),
          (-1,
           0),
          'CENTER')])
        return tabla



    def dibujaEsquemas(self, hoja = None):
        celda = []
        esquema = self.dameEsquema(hoja)
        celda.append([esquema])
        celda.append([XPreformatted('(1) Deber\xe1 indicarse las caracter\xedsticas de los dispositivos de corte y protecci\xf3n adoptados, puntos de utilizaci\xf3n, secciones de los conductores y di\xe1metro\nde los tubos\n(2) Podr\xe1n utilizarse tantas hojas de esquemas unificares como estime necesarias el redactor de la presente Memoria T\xe9cnica de Dise\xf1o', self.eNotas)])
        tCelda = Table(data=celda)
        tCelda.setStyle([('VALIGN',
          (0,
           1),
          (0,
           1),
          'BOTTOM'),
         ('LINEBELOW',
          (0,
           0),
          (0,
           0),
          0.25,
          colors.black)])
        tabla = []
        tabla.append([XPreformatted('<para><font size=9.5><b>8. ESQUEMAS UNIFILARES DE LA INSTALACI\xd3N.</b></font><font size=7.5>(1)(2)</font></para>', self.eNormal)])
        tabla.append([tCelda])
        t = Table(data=tabla, colWidths=[(19 * cm)], rowHeights=[(0.59999999999999998 * cm),
         (24 * cm)])
        t.setStyle([('GRID',
          (0,
           0),
          (-1,
           -1),
          0.25,
          colors.black),
         ('BACKGROUND',
          (0,
           0),
          (0,
           0),
          colors.Color(0.75, 0.75, 0.75)),
         ('VALIGN',
          (0,
           0),
          (0,
           0),
          'CENTER')])
        return t



    def dameEsquema(self, hoja = None):
        if (not hoja):
            return ''
        if hoja.esquemaAplicacion:
            try:
                bmp = PIL.Image.open(hoja.ficheroEsquemaAplicacion)
            except:
                return ''
            bmp = bmp.rotate(270)
            bmp = bmp.resize([520,
             630], PIL.Image.ANTIALIAS)
            import os
            nombreF = os.path.split(hoja.ficheroEsquemaAplicacion)
            bmp.save(('imagenes/esquemas/copia/' + nombreF[1]))
            return Image(('imagenes/esquemas/copia/' + nombreF[1]))
        if hoja.esquemaAdjunto:
            try:
                bmp = PIL.Image.open(hoja.ficheroEsquema)
            except:
                return ''
            bmp = bmp.resize([520,
             630], PIL.Image.ANTIALIAS)
            import os
            nombreF = os.path.split(hoja.ficheroEsquema)
            bmp.save(('imagenes/esquemas/copia/' + nombreF[1]))
            return Image(('imagenes/esquemas/copia/' + nombreF[1]))
        return ''



    def dibujaCroquis(self, dato = None, tipo = None):
        celda = []
        croquis = self.dameCroquis(dato, tipo)
        if (croquis == ''):
            celda.append([Paragraph('<para> </para>', self.eNormal)])
        elif (croquis.__class__ == str):
            celda.append([XPreformatted(croquis, self.eNormalTexto)])
        else:
            celda.append([croquis])
        celda.append([XPreformatted('(1)Deber\xe1n utilizarse tantas hojas de croquis y/o aportarse tantos planos de planta y alzado como sean necesarios para definir la instalaci\xf3n el\xe9ctrica de baja\n tensi\xf3n, relacion\xe1ndose los planos y alzados adjuntados en el punto \x939. Croquis reflejando el trazado \x85.\x94 de la presente Memoria.', self.eNotas)])
        tCelda = Table(data=celda, rowHeights=[(17 * cm),
         (1 * cm)])
        if ((croquis.__class__ == str) or (croquis.__class__ == unicode)):
            tCelda.setStyle([('VALIGN',
              (0,
               0),
              (0,
               0),
              'TOP'),
             ('VALIGN',
              (0,
               1),
              (0,
               1),
              'BOTTOM'),
             ('LINEBELOW',
              (0,
               0),
              (0,
               0),
              0.25,
              colors.black)])
        else:
            tCelda.setStyle([('VALIGN',
              (0,
               1),
              (0,
               1),
              'BOTTOM'),
             ('LINEBELOW',
              (0,
               0),
              (0,
               0),
              0.25,
              colors.black)])
        tabla = []
        tabla.append([XPreformatted('<para><font size=9.5><b>9. CROQUIS REFLEJANDO EL TRAZADO DE LA INSTALACI\xd3N ACOTADO O A ESCALA SUFICIENTE.</b></font><font size=7.5>(1)</font></para>', self.eNormal)])
        tabla.append([tCelda])
        t = Table(data=tabla, colWidths=[(19 * cm)], rowHeights=[(0.59999999999999998 * cm),
         (18 * cm)])
        t.setStyle([('GRID',
          (0,
           0),
          (-1,
           -1),
          0.25,
          colors.black),
         ('BACKGROUND',
          (0,
           0),
          (0,
           0),
          colors.Color(0.75, 0.75, 0.75)),
         ('VALIGN',
          (0,
           0),
          (0,
           0),
          'CENTER')])
        return t



    def dameCroquis(self, dato = None, tipo = None):
        if (dato == None):
            return ''
        if (tipo == 'texto'):
            return self.dameCadenaConLineas(dato, 120)
        if (tipo == 'imagen'):
            try:
                bmp = PIL.Image.open(dato)
            except:
                return ''
            bmp = bmp.resize([520,
             470], PIL.Image.ANTIALIAS)
            import os
            nombreF = os.path.split(dato)
            bmp.save(('imagenes/esquemas/copia/' + nombreF[1]))
            return Image(('imagenes/esquemas/copia/' + nombreF[1]))
        return ''



    def dibujaTitularRegistro(self):
        tabla = []
        tabla.append([Paragraph('<b>TITULAR DE LA INSTALACI\xd3N</b>', self.eCabecera)])
        tabla.append([self.dameTabla([(('Nombre o Raz\xf3n Social:\n<b><font size=8.5>' + self.instalacion.nombre) + '</font></b>'),
          (('D.N.I.-C.I.F.:\n<b><font size=8.5>' + self.instalacion.dni) + '</font></b>')], [(15 * cm),
          (4 * cm)])])
        tabla.append([self.dameTabla([(('Domicilio:\n<b><font size=8.5>' + self.instalacion.domicilio) + '</font></b>'),
          (('C\xf3digo Postal:\n<b><font size=8.5>' + self.instalacion.codigoPostal) + '</font></b>')], [(15 * cm),
          (4 * cm)])])
        tabla.append([self.dameTabla([(('Localidad:\n<b><font size=8.5>' + self.instalacion.localidad) + '</font></b>'),
          (('Provincia:\n<b><font size=8.5>' + self.instalacion.provincia) + '</font></b>'),
          (('Correo electr\xf3nico:\n<b><font size=8.5>' + self.instalacion.mail) + '</font></b>'),
          (('Tel\xe9fono:\n<b><font size=8.5>' + self.instalacion.telefono) + '</font></b>')], [(7 * cm),
          (2.5 * cm),
          (5.5 * cm),
          (4 * cm)])])
        tabla.append([self.dameTabla([(('Representante (1):\n<b><font size=8.5>' + self.instalacion.nombreRepresentante) + '</font></b>'),
          (('Correo electr\xf3nico:\n<b><font size=8.5>' + self.instalacion.correoRepresentante) + '</font></b>'),
          (('D.N.I.:\n<b><font size=8.5>' + self.instalacion.dniRepresentante) + '</font></b>')], [(9.5 * cm),
          (5.5 * cm),
          (4 * cm)])])
        t = Table(data=tabla, colWidths=[(19 * cm)], rowHeights=[(0.59999999999999998 * cm),
         (0.69999999999999996 * cm),
         (0.69999999999999996 * cm),
         (0.69999999999999996 * cm),
         (0.69999999999999996 * cm)])
        t.setStyle([('GRID',
          (0,
           0),
          (-1,
           -1),
          0.25,
          colors.black),
         ('BACKGROUND',
          (0,
           0),
          (0,
           0),
          colors.Color(0.75, 0.75, 0.75)),
         ('BOTTOMPADDING',
          (0,
           0),
          (-1,
           -1),
          0),
         ('LEFTPADDING',
          (0,
           1),
          (-1,
           -1),
          0),
         ('RIGHTPADDING',
          (0,
           1),
          (-1,
           -1),
          0),
         ('TOPPADDING',
          (0,
           0),
          (-1,
           -1),
          0),
         ('VALIGN',
          (0,
           0),
          (0,
           0),
          'CENTER'),
         ('VALIGN',
          (0,
           1),
          (-1,
           -1),
          'TOP'),
         ('ALIGN',
          (0,
           1),
          (-1,
           -1),
          'CENTER')])
        return t



    def dibujaDatosInstalacionRegistro(self):
        tabla = []
        tabla.append([Paragraph('<b>DATOS DE LA INSTALACI\xd3N</b>', self.eCabecera)])
        tabla.append([XPreformatted((('Emplazamiento:\n<b><font size=8.5>' + self.instalacion.IEmplazamiento) + '</font></b>'), self.eNormal)])
        tabla.append([self.dameTabla([(('Localidad:\n<b><font size=8.5>' + self.instalacion.Ilocalidad) + '</font></b>'),
          (('Provincia:\n<b><font size=8.5>' + self.instalacion.Iprovincia) + '</font></b>'),
          (('C\xf3digo Postal:\n<b><font size=8.5>' + self.instalacion.IcodigoPostal) + '</font></b>')], [(11 * cm),
          (4 * cm),
          (4 * cm)])])
        if (self.instalacion.ISuperficie == 0):
            superficieC = '\n'
        else:
            superficieC = str(self.instalacion.ISuperficie)
        if (self.instalacion.IOcupacion == 0):
            ocupacionC = ''
        else:
            ocupacionC = str(self.instalacion.IOcupacion)
        tabla.append([self.dameTabla([(('Uso al que se destina:\n<b><font size=8.5>' + self.instalacion.IUso) + '</font></b>'),
          (('Superficie(m<super>2</super>):\n<b><font size=8.5>' + superficieC) + '</font></b>'),
          (('Ocupaci\xf3n(2):\n<b><font size=8.5>' + ocupacionC) + '</font></b>'),
          (('Tipo de instalaci\xf3n(3)\n<b><font size=8.5>' + self.instalacion.ITipo) + '</font></b>')], [(7 * cm),
          (2 * cm),
          (2 * cm),
          (8 * cm)])])
        if (self.instalacion.potenciaInstalada == 0):
            potenciaInstaladaC = '\n'
        else:
            potenciaInstaladaC = str(self.instalacion.potenciaInstalada)
        tabla.append([self.dameTabla([self.dameTablaSinCeldas(['Instalaci\xf3n',
           'Nueva',
           'Ampliaci\xf3n',
           'Modificaci\xf3n'], [(1.5 * cm),
           (0.5 * cm),
           (2 * cm),
           (0.5 * cm),
           (2 * cm),
           (0.5 * cm),
           (2 * cm)], seleccionado=self.instalacion.IInstalacion),
          (('Potencia instalada o prevista (kW)(5): <font size=8.5><b>' + potenciaInstaladaC) + '</b></font>')], [(9 * cm),
          (10 * cm)], estilo=self.eNormalSalto4)])
        tabla.append([self.dameTabla([(('Empresa Instaladora:\n<b><font size=8.5>' + self.instalacion.REmpresa) + '</font></b>'),
          (('N\xba de Registro\n<b><font size=8.5>' + self.instalacion.RRegistro) + '</font></b>')], [(15.300000000000001 * cm),
          (3.7000000000000002 * cm)])])
        tabla.append([self.dameTabla([(('Instalador autorizado en baja tensi\xf3n:\n<b><font size=8.5>' + self.instalacion.Rnombre) + '</font></b>'),
          (('N\xba. Carn\xe9 de Instalador\n<b><font size=8.5>' + self.instalacion.RCarne) + '</font></b>'),
          (('Categoria - Especialidad (5):\n<b><font size=8.5>' + self.instalacion.RCategoria) + '</font></b>')], [(12.199999999999999 * cm),
          (3.1000000000000001 * cm),
          (3.7000000000000002 * cm)])])
        tabla.append([self.dameTabla([(('Representante (1):\n<b><font size=8.5>' + self.instalacion.RnombreRepresentante) + '</font></b>'),
          (('Correo electr\xf3nico:\n<b><font size=8.5>' + self.instalacion.RcorreoRepresentante) + '</font></b>'),
          (('D.N.I.:\n<b><font size=8.5>' + self.instalacion.RdniRepresentante) + '</font></b>')], [(9.1999999999999993 * cm),
          (6.0999999999999996 * cm),
          (3.7000000000000002 * cm)])])
        t = Table(data=tabla, colWidths=[(19 * cm)], rowHeights=[(0.59999999999999998 * cm),
         (0.69999999999999996 * cm),
         (0.69999999999999996 * cm),
         (0.69999999999999996 * cm),
         (0.40000000000000002 * cm),
         (0.69999999999999996 * cm),
         (0.69999999999999996 * cm),
         (0.69999999999999996 * cm)])
        t.setStyle([('GRID',
          (0,
           0),
          (-1,
           -1),
          0.25,
          colors.black),
         ('BACKGROUND',
          (0,
           0),
          (0,
           0),
          colors.Color(0.75, 0.75, 0.75)),
         ('BOTTOMPADDING',
          (0,
           1),
          (-1,
           -1),
          0),
         ('LEFTPADDING',
          (0,
           2),
          (-1,
           -1),
          0),
         ('RIGHTPADDING',
          (0,
           1),
          (-1,
           -1),
          0),
         ('TOPPADDING',
          (0,
           1),
          (-1,
           -1),
          0),
         ('VALIGN',
          (0,
           0),
          (0,
           0),
          'CENTER'),
         ('VALIGN',
          (0,
           1),
          (-1,
           -1),
          'CENTER'),
         ('ALIGN',
          (0,
           1),
          (-1,
           -1),
          'CENTER')])
        return t



    def dibujaDocumentacion(self):
        tabla = []
        tabla.append([Paragraph('<b>DOCUMENTACI\xd3N QUE SE ADJUNTA DE LA INSTALACI\xd3N EL\xc9CTRICA</b>', self.eCabecera)])
        tabla.append([self.dameListaDocumentacion()])
        t = Table(data=tabla, colWidths=[(19 * cm)], rowHeights=[(0.59999999999999998 * cm),
         (4.2000000000000002 * cm)])
        t.setStyle([('GRID',
          (0,
           0),
          (-1,
           -1),
          0.25,
          colors.black),
         ('BACKGROUND',
          (0,
           0),
          (0,
           0),
          colors.Color(0.75, 0.75, 0.75)),
         ('BOTTOMPADDING',
          (0,
           0),
          (-1,
           -1),
          0),
         ('LEFTPADDING',
          (0,
           1),
          (-1,
           -1),
          0),
         ('RIGHTPADDING',
          (0,
           1),
          (-1,
           -1),
          0),
         ('TOPPADDING',
          (0,
           0),
          (-1,
           -1),
          0),
         ('VALIGN',
          (0,
           0),
          (0,
           0),
          'CENTER'),
         ('VALIGN',
          (0,
           1),
          (-1,
           -1),
          'TOP'),
         ('ALIGN',
          (0,
           1),
          (-1,
           -1),
          'CENTER')])
        return t



    def dameListaDocumentacion(self):
        tablaIzquierda = []
        dato = []
        for elemento in self.instalacion.documentos:
            if elemento:
                dato.append(1)
            else:
                dato.append(None)

        tablaIzquierda.append([self.dameCadenaConSelector('Memoria T\xe9cnica de Dise\xf1o', seleccionado=dato[0])])
        tablaIzquierda.append([self.dameCadenaConSelector('Proyecto T\xe9cnico', seleccionado=dato[2])])
        tablaIzquierda.append([self.dameCadenaConSelector('Certificado de Direcci\xf3n de obra', seleccionado=dato[4])])
        tablaIzquierda.append([self.dameCadenaConSelector('Certificado de Inspecci\xf3n Inicial', seleccionado=dato[6])])
        tablaIzquierda.append([self.dameCadenaConSelector('Certificado de Instalaci\xf3n El\xe9ctrica de Baja Tensi\xf3n y anexo', [(0.40000000000000002 * cm),
          (7 * cm)], seleccionado=dato[8])])
        tablaIzquierda.append([XPreformatted('           de informacion al usuario', self.eNormalSalto)])
        tablaIzquierda.append([self.dameCadenaConSelector('Anexo indicativo y justificativo de las variaciones habidas en la', [(0.40000000000000002 * cm),
          (8 * cm)], seleccionado=dato[10])])
        tablaIzquierda.append([XPreformatted('            ejecuci\xf3n de la instalacion respecto a la documentaci\xf3n t\xe9cnica inicial', self.eNormalSalto)])
        tablaIzquierda.append([self.dameCadenaConSelector('Autorizaci\xf3n de otras instlaciones industriales existentes en el mismo', [(0.40000000000000002 * cm),
          (8 * cm)], seleccionado=dato[12])])
        tablaIzquierda.append([XPreformatted('             emplazamiento', self.eNormalSalto)])
        tablaIzquierda.append([self.dameCadenaConSelector(('Otra documentaci\xf3n: ' + self.instalacion.otrosDocumentos), seleccionado=dato[13])])
        tablaIzquierda = Table(data=tablaIzquierda, colWidths=[(9.5 * cm)], rowHeights=[(0.40000000000000002 * cm),
         (0.40000000000000002 * cm),
         (0.40000000000000002 * cm),
         (0.40000000000000002 * cm),
         (0.40000000000000002 * cm),
         (0.40000000000000002 * cm),
         (0.10000000000000001 * cm),
         (0.40000000000000002 * cm),
         (0.10000000000000001 * cm),
         (0.40000000000000002 * cm),
         (0.40000000000000002 * cm)])
        tablaDerecha = []
        tablaDerecha.append([self.dameCadenaConSelector('Acreditaci\xf3n de representaci\xf3n o apoderamiento', seleccionado=dato[1])])
        tablaDerecha.append([self.dameCadenaConSelector('Informe y/o autorizaci\xf3n de Medio Ambiente', seleccionado=dato[3])])
        tablaDerecha.append([self.dameCadenaConSelector('Permisos de paso de zonas de afecci\xf3n de las instalaciones el\xe9ctricas', [(0.40000000000000002 * cm),
          (8 * cm)], seleccionado=dato[5])])
        tablaDerecha.append([self.dameCadenaConSelector('Hoja de datos complementarios paara instalaciones el\xe9ctricas para obras', [(0.40000000000000002 * cm),
          (9 * cm)], seleccionado=dato[7])])
        tablaDerecha.append([self.dameCadenaConSelector('Copia de insc. en el Registro de Establecimientos Industriales de la', [(0.40000000000000002 * cm),
          (8 * cm)], seleccionado=dato[9])])
        tablaDerecha.append([XPreformatted('           maquinaria de obra y documento de calificaci\xf3n empresarial (D.C.E.). ', self.eNormalSalto3)])
        tablaDerecha.append([self.dameCadenaConSelector('Informe de resultados de controles realizados en Quirofanos y Salas', [(0.40000000000000002 * cm),
          (8 * cm)], seleccionado=dato[11])])
        tablaDerecha.append([XPreformatted('            de Intervenci\xf3n seg\xedn ITC-BT-38', self.eNormalSalto)])
        tablaDerecha.append([Paragraph('<para> </para>', self.eNormal)])
        tablaDerecha = Table(data=tablaDerecha, colWidths=[(9.5 * cm)], rowHeights=[(0.40000000000000002 * cm),
         (0.40000000000000002 * cm),
         (0.40000000000000002 * cm),
         (0.40000000000000002 * cm),
         (0.40000000000000002 * cm),
         (0.29999999999999999 * cm),
         (0.40000000000000002 * cm),
         (0.40000000000000002 * cm),
         (0.80000000000000004 * cm)])
        tabla = []
        tabla.append([tablaIzquierda,
         tablaDerecha])
        t = Table(data=tabla, colWidths=[(9.5 * cm),
         (9.5 * cm)])
        return t



    def dibujaDatosRegistro(self):
        tabla = []
        tabla.append([Paragraph('<b>DATOS SOBRE EL REGISTRO INDUSTRIAL</b>. (5)', self.eCabecera)])
        tabla.append([self.dameListaRegistro()])
        t = Table(data=tabla, colWidths=[(19 * cm)], rowHeights=[(0.59999999999999998 * cm),
         (1 * cm)])
        t.setStyle([('GRID',
          (0,
           0),
          (-1,
           -1),
          0.25,
          colors.black),
         ('BACKGROUND',
          (0,
           0),
          (0,
           0),
          colors.Color(0.75, 0.75, 0.75)),
         ('BOTTOMPADDING',
          (0,
           0),
          (-1,
           -1),
          0),
         ('LEFTPADDING',
          (0,
           1),
          (-1,
           -1),
          0),
         ('RIGHTPADDING',
          (0,
           1),
          (-1,
           -1),
          0),
         ('TOPPADDING',
          (0,
           0),
          (-1,
           -1),
          0),
         ('VALIGN',
          (0,
           0),
          (0,
           0),
          'CENTER'),
         ('VALIGN',
          (0,
           1),
          (-1,
           -1),
          'TOP'),
         ('ALIGN',
          (0,
           1),
          (-1,
           -1),
          'CENTER')])
        return t



    def dameListaRegistro(self):
        tabla = []
        if (self.instalacion.solicitud == 0):
            dato = None
        else:
            dato = 1
        tabla.append([self.dameCadenaConSelector('Se aporta solicitud de iniciaci\xf3n de expediente para la comunicaci\xf3n de datos al Registro de Establecimientos Industriales', [(0.40000000000000002 * cm),
          (16 * cm)], seleccionado=dato)])
        dato = []
        for elemento in self.instalacion.datosRegistro:
            if elemento:
                dato.append(1)
            else:
                dato.append(None)

        tablaInferior = []
        tablaInferior.append([self.dameCadenaConSelector('Nuevo establecimiento', seleccionado=dato[0]),
         self.dameCadenaConSelector(('Establecimiento dado de alta en el Registro con N\xfamero: ' + self.instalacion.numeroRegistro), [(0.40000000000000002 * cm),
          (10 * cm)], seleccionado=dato[1])])
        tablaInferior = Table(data=tablaInferior)
        tabla.append([tablaInferior])
        t = Table(data=tabla)
        t.setStyle([('TOPPADDING',
          (0,
           0),
          (-1,
           -1),
          0),
         ('VALIGN',
          (0,
           1),
          (-1,
           -1),
          'TOP')])
        return t



    def dibujaOtrasInstalaciones(self):
        tabla = []
        if (not (self.instalacion.fechaFirma == '')):
            datos = self.instalacion.fechaFirma.split('/')
        else:
            datos = ['',
             '',
             '']
        tabla.append([Paragraph('<b>OTRAS INSTALACIONES INDUSTRIALES EXISTENTES EN EL MISMO EMPLAZAMIENTO</b>', self.eCabecera)])
        tabla.append([self.dameListaOtrasInstalaciones()])
        tabla.append([XPreformatted((((((((('                 Declaramos bajo nuestra responsabilidad que los datos indicados en el presente documento son ciertos por lo que, en aplicaci\xf3n del vigente Reglamento\n Electrot\xe9cnico para Baja Tensi\xf3n aprobado por el Real Decreto 842/2.002, de 2 de agosto, se solicita que se proceda por ese Organismo seg\xfan corresponda.\n\n                                                          ' + self.instalacion.lugar) + ' ,a ') + datos[0]) + ' de ') + datos[1]) + ' de ') + datos[2]) + '\n\n\n\n                                        (Firma y sello del titular o representante)                          (Firma y sello del Instalador autorizado o representante)'), self.eNormalSalto)])
        t = Table(data=tabla, colWidths=[(19 * cm)], rowHeights=[(0.59999999999999998 * cm),
         (3 * cm),
         (3.2000000000000002 * cm)])
        t.setStyle([('GRID',
          (0,
           0),
          (-1,
           -1),
          0.25,
          colors.black),
         ('BACKGROUND',
          (0,
           0),
          (0,
           0),
          colors.Color(0.75, 0.75, 0.75)),
         ('BOTTOMPADDING',
          (0,
           0),
          (-1,
           -1),
          0),
         ('LEFTPADDING',
          (0,
           1),
          (-1,
           -1),
          0),
         ('RIGHTPADDING',
          (0,
           1),
          (-1,
           -1),
          0),
         ('TOPPADDING',
          (0,
           0),
          (-1,
           -1),
          0),
         ('VALIGN',
          (0,
           0),
          (0,
           0),
          'CENTER'),
         ('VALIGN',
          (0,
           1),
          (-1,
           -1),
          'TOP'),
         ('ALIGN',
          (0,
           1),
          (-1,
           -1),
          'CENTER')])
        return t



    def dameListaOtrasInstalaciones(self):
        dato = []
        for elemento in self.instalacion.otrasInstalaciones:
            if elemento:
                dato.append(1)
            else:
                dato.append(None)

        tablaIzquierda = []
        tablaIzquierda.append([self.dameCadenaConSelector('El\xe9ctrica de alta tensi\xf3n', seleccionado=dato[0])])
        tablaIzquierda.append([self.dameCadenaConSelector('T\xe9rmicas en edificios', seleccionado=dato[2])])
        tablaIzquierda.append([XPreformatted('            (Calefacci\xf3n, climatizaci\xf3n y agua caliente sanitaria)', self.eNormalSalto)])
        tablaIzquierda.append([self.dameCadenaConSelector('Ascensores/Gr\xfaas', seleccionado=dato[4])])
        tablaIzquierda.append([self.dameCadenaConSelector('Almacenamientos de productos quimicos', seleccionado=dato[6])])
        tablaIzquierda.append([self.dameCadenaConSelector('Aparatos a presion', seleccionado=dato[8])])
        tablaIzquierda.append([self.dameCadenaConSelector(('Otras instalaciones: ' + self.instalacion.otrasInstalacionesTexto), seleccionado=dato[10])])
        tablaIzquierda = Table(data=tablaIzquierda, colWidths=[(9.5 * cm)], rowHeights=[(0.40000000000000002 * cm),
         (0.40000000000000002 * cm),
         (0.40000000000000002 * cm),
         (0.40000000000000002 * cm),
         (0.40000000000000002 * cm),
         (0.40000000000000002 * cm),
         (0.40000000000000002 * cm)])
        tablaDerecha = []
        tablaDerecha.append([self.dameCadenaConSelector('Proteccion contra incendios en establecimientos industriales.', [(0.40000000000000002 * cm),
          (9 * cm)], seleccionado=dato[1])])
        tablaDerecha.append([self.dameCadenaConSelector('Frigor\xedficas.', seleccionado=dato[3])])
        tablaDerecha.append([self.dameCadenaConSelector('Seguridad en m\xe1quinas', [(0.40000000000000002 * cm),
          (8 * cm)], seleccionado=dato[5])])
        tablaDerecha.append([self.dameCadenaConSelector('Almacenamiento de productos petrol\xedferos.', [(0.40000000000000002 * cm),
          (9 * cm)], seleccionado=dato[7])])
        tablaDerecha.append([self.dameCadenaConSelector('Gas.', [(0.40000000000000002 * cm),
          (8 * cm)], seleccionado=dato[9])])
        tablaDerecha.append([self.dameCadenaConSelector('Interiores de Agua.', [(0.40000000000000002 * cm),
          (8 * cm)], seleccionado=dato[11])])
        tablaDerecha.append([Paragraph('<para> </para>', self.eNormal)])
        tablaDerecha = Table(data=tablaDerecha, colWidths=[(9.5 * cm)], rowHeights=[(0.40000000000000002 * cm),
         (0.40000000000000002 * cm),
         (0.40000000000000002 * cm),
         (0.40000000000000002 * cm),
         (0.40000000000000002 * cm),
         (0.40000000000000002 * cm),
         (0.40000000000000002 * cm)])
        tabla = []
        tabla.append([tablaIzquierda,
         tablaDerecha])
        t = Table(data=tabla, colWidths=[(9.5 * cm),
         (9.5 * cm)])
        return t



    def dibujaTitularCertificado(self):
        tabla = []
        tabla.append([Paragraph('<b>TITULAR DE LA INSTALACI\xd3N</b>', self.eCabecera)])
        tabla.append([self.dameTabla([(('Nombre o Raz\xf3n Social:\n<b><font size=8.5>' + self.instalacion.nombre) + '</font></b>'),
          (('D.N.I.-C.I.F.:\n<b><font size=8.5>' + self.instalacion.dni) + '</font></b>')], [(15 * cm),
          (4 * cm)])])
        tabla.append([self.dameTabla([(('Domicilio:\n<b><font size=8.5>' + self.instalacion.domicilio) + '</font></b>'),
          (('C\xf3digo Postal:\n<b><font size=8.5>' + self.instalacion.codigoPostal) + '</font></b>')], [(15 * cm),
          (4 * cm)])])
        tabla.append([self.dameTabla([(('Localidad:\n<b><font size=8.5>' + self.instalacion.localidad) + '</font></b>'),
          (('Provincia:\n<b><font size=8.5>' + self.instalacion.provincia) + '</font></b>'),
          (('Correo electr\xf3nico:\n<b><font size=8.5>' + self.instalacion.mail) + '</font></b>'),
          (('Tel\xe9fono:\n<b><font size=8.5>' + self.instalacion.telefono) + '</font></b>')], [(7 * cm),
          (2.5 * cm),
          (5.5 * cm),
          (4 * cm)])])
        t = Table(data=tabla, colWidths=[(19 * cm)], rowHeights=[(0.59999999999999998 * cm),
         (0.69999999999999996 * cm),
         (0.69999999999999996 * cm),
         (0.69999999999999996 * cm)])
        t.setStyle([('GRID',
          (0,
           0),
          (-1,
           -1),
          0.25,
          colors.black),
         ('BACKGROUND',
          (0,
           0),
          (0,
           0),
          colors.Color(0.75, 0.75, 0.75)),
         ('BOTTOMPADDING',
          (0,
           0),
          (-1,
           -1),
          0),
         ('LEFTPADDING',
          (0,
           1),
          (-1,
           -1),
          0),
         ('RIGHTPADDING',
          (0,
           1),
          (-1,
           -1),
          0),
         ('TOPPADDING',
          (0,
           0),
          (-1,
           -1),
          0),
         ('VALIGN',
          (0,
           0),
          (0,
           0),
          'CENTER'),
         ('VALIGN',
          (0,
           1),
          (-1,
           -1),
          'TOP'),
         ('ALIGN',
          (0,
           1),
          (-1,
           -1),
          'CENTER')])
        return t



    def dibujaDatosInstalacionCertificado(self):
        tabla = []
        tabla.append([Paragraph('<b>DATOS DE LA INSTALACI\xd3N</b>', self.eCabecera)])
        tabla.append([XPreformatted((('Emplazamiento:\n<b><font size=8.5>' + self.instalacion.IEmplazamiento) + '</font></b>'), self.eNormal)])
        tabla.append([self.dameTabla([(('Localidad:\n<b><font size=8.5>' + self.instalacion.Ilocalidad) + '</font></b>'),
          (('Provincia:\n<b><font size=8.5>' + self.instalacion.Iprovincia) + '</font></b>'),
          'Correo electr\xf3nico:\n<b><font size=8.5> </font></b>',
          (('C\xf3digo Postal:\n<b><font size=8.5>' + self.instalacion.IcodigoPostal) + '</font></b>')], [(7 * cm),
          (3 * cm),
          (5 * cm),
          (4 * cm)])])
        if (self.instalacion.ISuperficie == 0):
            superficieC = '\n'
        else:
            superficieC = str(self.instalacion.ISuperficie)
        if (self.instalacion.IOcupacion == 0):
            ocupacionC = ''
        else:
            ocupacionC = str(self.instalacion.IOcupacion)
        tabla.append([self.dameTabla([(('Uso al que se destina:\n<b><font size=8.5>' + self.instalacion.IUso) + '</font></b>'),
          (('Superficie(m<super>2</super>):\n<b><font size=8.5>' + superficieC) + '</font></b>'),
          (('Ocupaci\xf3n(1):\n<b><font size=8.5>' + ocupacionC) + '</font></b>'),
          (('Tipo de instalaci\xf3n(2)\n<b><font size=8.5>' + self.instalacion.ITipo) + '</font></b>')], [(7 * cm),
          (2 * cm),
          (2 * cm),
          (8 * cm)])])
        tabla.append([self.dameTablaSinCeldas(['Instalaci\xf3n',
          'Nueva',
          'Ampliaci\xf3n',
          'Modificaci\xf3n'], [(7 * cm),
          (0.5 * cm),
          (3 * cm),
          (0.5 * cm),
          (3 * cm),
          (0.5 * cm),
          (3 * cm)], seleccionado=self.instalacion.IInstalacion)])
        tabla.append([self.dibujaTablaInstalacionesTemporales()])
        t = Table(data=tabla, colWidths=[(19 * cm)], rowHeights=[(0.59999999999999998 * cm),
         (0.69999999999999996 * cm),
         (0.69999999999999996 * cm),
         (0.69999999999999996 * cm),
         (0.40000000000000002 * cm),
         (1.6000000000000001 * cm)])
        t.setStyle([('GRID',
          (0,
           0),
          (-1,
           -1),
          0.25,
          colors.black),
         ('BACKGROUND',
          (0,
           0),
          (0,
           0),
          colors.Color(0.75, 0.75, 0.75)),
         ('BOTTOMPADDING',
          (0,
           1),
          (-1,
           -1),
          0),
         ('LEFTPADDING',
          (0,
           2),
          (-1,
           -1),
          0),
         ('RIGHTPADDING',
          (0,
           1),
          (-1,
           -1),
          0),
         ('TOPPADDING',
          (0,
           1),
          (-1,
           -1),
          0),
         ('VALIGN',
          (0,
           0),
          (0,
           0),
          'CENTER'),
         ('VALIGN',
          (0,
           1),
          (-1,
           -1),
          'CENTER'),
         ('ALIGN',
          (0,
           1),
          (-1,
           -1),
          'CENTER')])
        return t



    def dibujaTablaInstalacionesTemporales(self):
        if (not (self.instalacion.ITipo == '')):
            if (self.instalacion.ITipo[0] == 'd'):
                fecha = ((self.instalacion.IfechaDesde + ' - ') + self.instalacion.IfechaHasta)
                seleccion = 0
            else:
                fecha = ''
                seleccion = None
        else:
            fecha = ''
            seleccion = None
        tabla = []
        tabla.append([XPreformatted((('Instalaciones temporales de ferias, exposiciones y similares:               Plazo de validez:<b><font size=8.5> ' + fecha) + '</font></b>'), self.eNormalSalto)])
        tabla.append([self.dameTablaSinCeldas(['',
          'Declaro que el montaje de la instalaci\xf3n se repite de forma id\xe9ntica, teniendo validez esta circunstancia (3) hasta (maximo 1 a\xf1o): El numero de expediente de la documentaci\xf3n t\xe9cnica de la instalaci\xf3n es:'], [(1 * cm),
          (0.5 * cm),
          (14 * cm)], seleccionado=seleccion)])
        t = Table(data=tabla)
        t.setStyle([('VALIGN',
          (0,
           0),
          (0,
           0),
          'BOTTOM')])
        return t



    def dibujaCaracteristicasGenerales(self):
        tabla = []
        tabla.append([Paragraph('<b>CARACTERISTICAS GENERALES DE LA INSTALACI\xd3N</b>', self.eCabecera)])
        tabla.append([self.dibujaTablaCajaGeneral()])
        if self.instalacion.compruebaProyecto():
            tabla.append([self.dibujaTablaLineaGeneralProyecto()])
            tabla.append([self.dibujaTablaDerivacionIndividualProyecto()])
        else:
            tabla.append([self.dibujaTablaLineaGeneral()])
            tabla.append([self.dibujaTablaDerivacionIndividual()])
        tabla.append([self.dameTabla([['Tipo Suminstro:',
           'Monof\xe1sico',
           'Trif\xe1sico'],
          (('Tensi\xf3n suministro (V)(7): <b><font size = 8.5>' + str(self.instalacion.tensionSuministro)) + '</font></b>'),
          (('Empresa distribuidora: <b><font size = 8.5>' + self.instalacion.empresa) + '</font></b>')], [(6.2999999999999998 * cm),
          (5.7000000000000002 * cm),
          (7 * cm)], estilo=self.eNormalSalto, dato=self.instalacion.tipoSuministro)])
        di = self.instalacion.dameDI()
        if (not (di.__class__ == str)):
            potencia = ((di.intensidadAdmisible * float(di.LTension)) / 1000)
            if (di.fase == 1):
                import math
                potencia = (potencia * math.sqrt(3))
            potencia = str(round(potencia, 2))
        else:
            potencia = ''
        if self.instalacion.compruebaProyecto():
            if (self.instalacion.potenciaDI == 0):
                potencia = ''
            else:
                potencia = str(self.instalacion.potenciaDI)
        if (self.instalacion.potenciaInstalada == 0):
            potenciaInstaladaC = ''
        else:
            potenciaInstaladaC = str(self.instalacion.potenciaInstalada)
        if (self.instalacion.totalPotenciaContratar == 0):
            totalPotenciaContratarC = ''
        else:
            totalPotenciaContratarC = str(self.instalacion.totalPotenciaContratar)
        tabla.append([self.dameTabla([(('Pot. instalada o prevista (kW) <b><font size = 8.5>' + potenciaInstaladaC) + '</font></b>'),
          (('Pot. M\xe1xima a contratar (kW)(8) <b><font size = 8.5>' + totalPotenciaContratarC) + '</font></b>'),
          (('Pot. M\xe1xima Adm. Deriv. Ind. (kW)(9): <b><font size=8.5>' + str(potencia)) + '</b></font>')], [(6.2999999999999998 * cm),
          (5.7000000000000002 * cm),
          (7 * cm)], estilo=self.eNormalSalto)])
        tabla.append([self.dibujaCuadrado()])
        tabla.append([self.dameTabla(['Sistema empleado para la protecci\xf3n contra contactos indirectos (11):',
          (('Conductores de Tierra (4)(12)\n<b><font size=8.5>' + self.instalacion.conductores) + '</font></b>')], [(10 * cm),
          (9 * cm)])])
        if (self.instalacion.resistenciaTierra == 0):
            resistenciaTierraC = ''
        else:
            resistenciaTierraC = str(self.instalacion.resistenciaTierra)
        if (self.instalacion.resistenciaAislamiento == 0):
            resistenciaAislamientoC = ''
        else:
            resistenciaAislamientoC = str(self.instalacion.resistenciaAislamiento)
        tabla.append([self.dameTabla([(('Resistencia puesta a tierra (&#937;)(4):\n<b><font size=8.5>' + resistenciaTierraC) + '</font></b>'),
          (('Resitencia de aislamiento de la instalaci\xf3n (k&#937;)\n<b><font size=8.5>' + resistenciaAislamientoC) + '</font></b>')], [(8.3000000000000007 * cm),
          (10.699999999999999 * cm)])])
        tabla.append([self.dibujaTablaOrganismo()])
        tabla.append([self.dameTabla([(('Empresa Instaladora :\n<b><font size=8.5>' + str(self.instalacion.REmpresa)) + '</font></b>'),
          (('N\xba de registro\n<b><font size=8.5>' + str(self.instalacion.RRegistro)) + '</font></b>')], [(14.699999999999999 * cm),
          (4.2999999999999998 * cm)])])
        tabla.append([self.dameTabla([(('Instalador autorizado en baja tensi\xf3n\n<b><font size=8.5>' + self.instalacion.Rnombre) + '</font></b>'),
          (('N\xba. Carn\xe9 de Instalador\n<b><font size=8.5>' + self.instalacion.RCarne) + '</font></b>'),
          (('Categoria-Especialidad (4)\n<b><font size=8.5>' + self.instalacion.RCategoria) + '</font></b>')], [(10 * cm),
          (4.7000000000000002 * cm),
          (4.2999999999999998 * cm)])])
        tabla.append([XPreformatted((('                Fecha en la que el instalador autorizado que suscribe el presente certificado ha realizado las verificaciones correspondientes, seg\xfan la Reglamentaci\xf3n vigente de\n    aplicaci\xf3n, a la instalaci\xf3n el\xe9ctrica de baja tensi\xf3n <b><font size=8.5>' + self.instalacion.fechaBajaTension) + '</b></font>'), self.eNormalSalto)])
        if (not (self.instalacion.fechaFirma == '')):
            datos = self.instalacion.fechaFirma.split('/')
        else:
            datos = ['',
             '',
             '']
        tabla.append([XPreformatted((((((((('                    El instalador autorizado en baja tensi\xf3n que suscribe, inscrito en esta Direcci\xf3n General y con el n\xfamero de carn\xe9 de instalador para baja\ntensi\xf3n arriba indicado, <b>CERTIFICA</b> haber ejecutado la instalaci\xf3n de acuerdo con las prescripciones del vigente Reglamento Electrot\xe9cnico para Baja Tensi\xf3n e\ninstrucciones ITC-BT espec\xedficas que le son de aplicaci\xf3n, normas particulares de la empresa distribuidora oficialmente aprobadas y con el Proyecto T\xe9cnico /\nMemoria T\xe9cnica de Dise\xf1o (t\xe1chese lo que no proceda).\n                                                          ' + self.instalacion.lugar) + ' ,a ') + datos[0]) + ' de ') + datos[1]) + ' de ') + datos[2]) + '\n\n\n\n\n                                                                                          (Firma y sello del Instalador Autorizado)'), self.eNormalSalto)])
        t = Table(data=tabla, colWidths=[(19 * cm)], rowHeights=[(0.59999999999999998 * cm),
         (0.80000000000000004 * cm),
         (0.80000000000000004 * cm),
         (0.80000000000000004 * cm),
         (0.59999999999999998 * cm),
         (0.59999999999999998 * cm),
         (2.2000000000000002 * cm),
         (0.69999999999999996 * cm),
         (0.69999999999999996 * cm),
         (0.69999999999999996 * cm),
         (0.69999999999999996 * cm),
         (0.69999999999999996 * cm),
         (0.80000000000000004 * cm),
         (3.7999999999999998 * cm)])
        t.setStyle([('GRID',
          (0,
           0),
          (-1,
           -1),
          0.25,
          colors.black),
         ('BACKGROUND',
          (0,
           0),
          (0,
           0),
          colors.Color(0.75, 0.75, 0.75)),
         ('BOTTOMPADDING',
          (0,
           0),
          (-1,
           -1),
          0),
         ('LEFTPADDING',
          (0,
           1),
          (-1,
           -1),
          0),
         ('RIGHTPADDING',
          (0,
           1),
          (-1,
           -1),
          0),
         ('TOPPADDING',
          (0,
           0),
          (-1,
           -1),
          0),
         ('VALIGN',
          (0,
           0),
          (0,
           0),
          'CENTER'),
         ('VALIGN',
          (0,
           1),
          (-1,
           -1),
          'TOP'),
         ('ALIGN',
          (0,
           1),
          (-1,
           -1),
          'CENTER'),
         ('LINEBELOW',
          (0,
           1),
          (0,
           1),
          1,
          colors.black),
         ('LINEBELOW',
          (0,
           2),
          (0,
           2),
          1,
          colors.black),
         ('LINEBELOW',
          (0,
           3),
          (0,
           3),
          1,
          colors.black),
         ('LINEBELOW',
          (0,
           5),
          (0,
           5),
          1,
          colors.black),
         ('LINEBELOW',
          (0,
           6),
          (0,
           6),
          1,
          colors.black),
         ('LINEBELOW',
          (0,
           8),
          (0,
           8),
          1,
          colors.black),
         ('LINEBELOW',
          (0,
           9),
          (0,
           9),
          1,
          colors.black)])
        return t



    def dibujaTablaCajaGeneral(self):
        tabla = []
        tabla.append([XPreformatted('<para>Caja General de Protecci\xf3n:</para>', self.eNormalSalto)])
        if (self.instalacion.inBase1 == 0):
            inBase1C = ''
        else:
            inBase1C = str(self.instalacion.inBase1)
        if (self.instalacion.inFusible1 == 0):
            inFusible1C = ''
        else:
            inFusible1C = str(self.instalacion.inFusible1)
        if (self.instalacion.inPotencia1 == 0):
            inPotencia1C = ''
        else:
            inPotencia1C = str(self.instalacion.inPotencia1)
        tabla.append([XPreformatted((((((('<para>                                                                   I<sub>N</sub> bases (A): <b>' + inBase1C) + '</b>                          I<sub>N</sub> fusibles (A): <b>') + inFusible1C) + '</b>                       Poder de corte del fusible (kA): <b>') + inPotencia1C) + '</b></para>'), self.eNormalSalto)])
        t = Table(data=tabla)
        t.setStyle(self.eTablaInterna)
        return t



    def dibujaTablaLineaGeneral(self):
        lga = self.dameDatosLGA()
        lga2 = self.instalacion.dameLGA()
        if (not (lga2.__class__ == str)):
            potencia = ((lga2.intensidadAdmisible * float(lga2.LTension)) / 1000)
            if (lga2.fase == 1):
                import math
                potencia = (potencia * math.sqrt(3))
            potencia = str(round(potencia, 2))
        else:
            potencia = ''
        tabla = []
        tabla.append([XPreformatted((('Linea General de alimentaci\xf3n (4):\n  Instalaci\xf3n. (5) <b><font size=8.5>' + lga[0][0]) + '</b></font>'), self.eNormalSalto),
         XPreformatted((('Conductor\n<b><font size=8.5>' + lga[0][1]) + '</b></font>'), self.eNormalSalto),
         XPreformatted((('Secci\xf3n fase/neutro\n<b><font size=8.5>' + lga[0][2]) + '</b></font> (mm<super>2</super>)'), self.eNormalSalto),
         XPreformatted((('Mat. aislamiento\n<b><font size=8.5>' + lga[0][3]) + '</b></font>'), self.eNormalSalto),
         XPreformatted((('Pot. M\xe1x. Admisible de L.G.A.\n<b><font size=8.5>' + str(potencia)) + '(kW)'), self.eNormalSalto)])
        t = Table(data=tabla, colWidths=[(8.1999999999999993 * cm),
         (1.7 * cm),
         (2.7000000000000002 * cm),
         (2.2000000000000002 * cm),
         (4.2000000000000002 * cm)], rowHeights=[(0.80000000000000004 * cm)])
        t.setStyle([('LINEAFTER',
          (0,
           0),
          (-1,
           -1),
          0.25,
          colors.black),
         ('TOPPADDING',
          (0,
           0),
          (-1,
           -1),
          0),
         ('RIGHTPADDING',
          (1,
           0),
          (-1,
           -1),
          0),
         ('VALIGN',
          (0,
           0),
          (0,
           0),
          'CENTER'),
         ('VALIGN',
          (1,
           0),
          (1,
           0),
          'TOP'),
         ('VALIGN',
          (2,
           0),
          (2,
           0),
          'CENTER'),
         ('VALIGN',
          (3,
           0),
          (3,
           0),
          'TOP'),
         ('VALIGN',
          (4,
           0),
          (4,
           0),
          'CENTER'),
         ('BOTTOMPADDING',
          (0,
           0),
          (-1,
           -1),
          0)])
        return t



    def dibujaTablaLineaGeneralProyecto(self):
        if (self.instalacion.potenciaLGA == 0):
            potencia = ''
        else:
            potencia = str(self.instalacion.potenciaLGA)
        tabla = []
        tabla.append([XPreformatted((('Linea General de alimentaci\xf3n (4):\n  Instalaci\xf3n. (5) <b><font size=8.5>' + self.instalacion.instalacionLGA) + '</b></font>'), self.eNormalSalto),
         XPreformatted((('Conductor\n<b><font size=8.5>' + self.instalacion.conductorLGA) + '</b></font>'), self.eNormalSalto),
         XPreformatted((('Secci\xf3n fase/neutro\n<b><font size=8.5>' + self.instalacion.seccionLGA) + '</b></font> (mm<super>2</super>)'), self.eNormalSalto),
         XPreformatted((('Mat. aislamiento\n<b><font size=8.5>' + self.instalacion.materialLGA) + '</b></font>'), self.eNormalSalto),
         XPreformatted((('Pot. M\xe1x. Admisible de L.G.A.\n<b><font size=8.5>' + potencia) + '(kW)'), self.eNormalSalto)])
        t = Table(data=tabla, colWidths=[(8.1999999999999993 * cm),
         (1.7 * cm),
         (2.7000000000000002 * cm),
         (2.2000000000000002 * cm),
         (4.2000000000000002 * cm)], rowHeights=[(0.80000000000000004 * cm)])
        t.setStyle([('LINEAFTER',
          (0,
           0),
          (-1,
           -1),
          0.25,
          colors.black),
         ('TOPPADDING',
          (0,
           0),
          (-1,
           -1),
          0),
         ('RIGHTPADDING',
          (1,
           0),
          (-1,
           -1),
          0),
         ('VALIGN',
          (0,
           0),
          (0,
           0),
          'CENTER'),
         ('VALIGN',
          (1,
           0),
          (1,
           0),
          'TOP'),
         ('VALIGN',
          (2,
           0),
          (2,
           0),
          'CENTER'),
         ('VALIGN',
          (3,
           0),
          (3,
           0),
          'TOP'),
         ('VALIGN',
          (4,
           0),
          (4,
           0),
          'CENTER'),
         ('BOTTOMPADDING',
          (0,
           0),
          (-1,
           -1),
          0)])
        return t



    def dibujaTablaDerivacionIndividual(self):
        lga = self.dameDatosLGA()
        di = self.dameDatosDI()
        tabla = []
        tabla.append([XPreformatted((('Derivaci\xf3n individual\n  Instalaci\xf3n. (5) <b><font size=8.5>' + di[0]) + '</b></font>'), self.eNormalSalto),
         XPreformatted((('Conductor\n<b><font size=8.5>' + di[1]) + '</b></font>'), self.eNormalSalto),
         XPreformatted((('Secci\xf3n fase/neut/CP\n<b><font size=8.5>' + di[3]) + '</b></font> (mm<super>2</super>)'), self.eNormalSalto),
         XPreformatted((('Mat. aislamiento\n<b><font size=8.5>' + di[4]) + '</b></font>'), self.eNormalSalto),
         XPreformatted((('Tensi\xf3n asignada\n<b><font size=8.5>' + di[2]) + '</b></font>(V)'), self.eNormalSalto),
         XPreformatted((('I<sub>N</sub> fusibles (6)\n<b><font size=8.5>' + lga[0][4]) + '</b></font>(A)'), self.eNormalSalto)])
        t = Table(data=tabla, colWidths=[(8.1999999999999993 * cm),
         (1.7 * cm),
         (2.7000000000000002 * cm),
         (2.2000000000000002 * cm),
         (2.1000000000000001 * cm),
         (2.1000000000000001 * cm)], rowHeights=[(0.80000000000000004 * cm)])
        t.setStyle([('LINEAFTER',
          (0,
           0),
          (-1,
           -1),
          0.25,
          colors.black),
         ('TOPPADDING',
          (0,
           0),
          (-1,
           -1),
          0),
         ('RIGHTPADDING',
          (1,
           0),
          (-1,
           -1),
          0),
         ('VALIGN',
          (0,
           0),
          (0,
           0),
          'CENTER'),
         ('VALIGN',
          (1,
           0),
          (1,
           0),
          'TOP'),
         ('VALIGN',
          (2,
           0),
          (2,
           0),
          'CENTER'),
         ('VALIGN',
          (3,
           0),
          (3,
           0),
          'TOP'),
         ('VALIGN',
          (4,
           0),
          (4,
           0),
          'CENTER'),
         ('BOTTOMPADDING',
          (0,
           0),
          (-1,
           -1),
          0)])
        return t



    def dibujaTablaDerivacionIndividualProyecto(self):
        if (self.instalacion.tensionDI == 0):
            tension = ''
        else:
            tension = str(self.instalacion.tensionDI)
        if (self.instalacion.intensidadDI == 0):
            intensidad = ''
        else:
            intensidad = str(self.instalacion.intensidadDI)
        tabla = []
        tabla.append([XPreformatted((('Derivaci\xf3n individual\n  Instalaci\xf3n. (5) <b><font size=8.5>' + self.instalacion.instalacionDI) + '</b></font>'), self.eNormalSalto),
         XPreformatted((('Conductor\n<b><font size=8.5>' + self.instalacion.conductorDI) + '</b></font>'), self.eNormalSalto),
         XPreformatted((('Secci\xf3n fase/neut/CP\n<b><font size=8.5>' + self.instalacion.seccionDI) + '</b></font> (mm<super>2</super>)'), self.eNormalSalto),
         XPreformatted((('Mat. aislamiento\n<b><font size=8.5>' + self.instalacion.materialDI) + '</b></font>'), self.eNormalSalto),
         XPreformatted((('Tensi\xf3n asignada\n<b><font size=8.5>' + tension) + '</b></font>(V)'), self.eNormalSalto),
         XPreformatted((('I<sub>N</sub> fusibles (6)\n<b><font size=8.5>' + intensidad) + '</b></font>(A)'), self.eNormalSalto)])
        t = Table(data=tabla, colWidths=[(8.1999999999999993 * cm),
         (1.7 * cm),
         (2.7000000000000002 * cm),
         (2.2000000000000002 * cm),
         (2.1000000000000001 * cm),
         (2.1000000000000001 * cm)], rowHeights=[(0.80000000000000004 * cm)])
        t.setStyle([('LINEAFTER',
          (0,
           0),
          (-1,
           -1),
          0.25,
          colors.black),
         ('TOPPADDING',
          (0,
           0),
          (-1,
           -1),
          0),
         ('RIGHTPADDING',
          (1,
           0),
          (-1,
           -1),
          0),
         ('VALIGN',
          (0,
           0),
          (0,
           0),
          'CENTER'),
         ('VALIGN',
          (1,
           0),
          (1,
           0),
          'TOP'),
         ('VALIGN',
          (2,
           0),
          (2,
           0),
          'CENTER'),
         ('VALIGN',
          (3,
           0),
          (3,
           0),
          'TOP'),
         ('VALIGN',
          (4,
           0),
          (4,
           0),
          'CENTER'),
         ('BOTTOMPADDING',
          (0,
           0),
          (-1,
           -1),
          0)])
        return t



    def dibujaTablaOrganismo(self):
        tabla = []
        tabla.append([XPreformatted((('Organismo de Control Acreditado que ha realizado la Inspecci\xf3n Inicial (4)\n                                                                                                     N\xba Acreditaci\xf3n <b><font size=8.5>' + self.instalacion.numeroOCA) + '</font></b>'), self.eNormalSalto),
         XPreformatted((((('Referencia y fecha de la Inspecci\xf3n Inicial Favorable realizada (4):\n<b><font size=8.5>' + self.instalacion.referenciaOCA) + '  ') + self.instalacion.fechaOCA) + '</font></b>'), self.eNormalSalto)])
        t = Table(data=tabla, colWidths=[(11 * cm),
         (8 * cm)], rowHeights=[(0.69999999999999996 * cm)])
        t.setStyle([('LINEAFTER',
          (0,
           0),
          (-1,
           -1),
          0.25,
          colors.black),
         ('TOPPADDING',
          (0,
           0),
          (-1,
           -1),
          0),
         ('RIGHTPADDING',
          (1,
           0),
          (-1,
           -1),
          0),
         ('VALIGN',
          (0,
           0),
          (0,
           0),
          'CENTER'),
         ('VALIGN',
          (1,
           0),
          (1,
           0),
          'TOP'),
         ('BOTTOMPADDING',
          (0,
           0),
          (-1,
           -1),
          0)])
        return t



    def dibujaPortada(self):
        tabla = []
        tabla.append([Paragraph('<b>ANEXO DE INFORMACI\xd3N AL USUARIO</b>', self.eTituloPortada)])
        tabla.append([Paragraph('<b>Titular de la instalaci\xf3n</b>', self.eCabeceraPortada)])
        tabla.append([self.datosTitular()])
        tabla.append([Paragraph('<b>Datos de la instalaci\xf3n</b>', self.eCabeceraPortada)])
        tabla.append([self.datosInstalacion()])
        tabla.append([Paragraph('<b>Datos del redactor</b>', self.eCabeceraPortada)])
        tabla.append([self.datosRedactor()])
        tabla.append([Paragraph((((('Firma en ' + self.instalacion.lugar) + ' a ') + self.instalacion.fechaFirma) + ' :'), self.eFirma)])
        t = Table(data=tabla, colWidths=[(19 * cm)], rowHeights=[(8 * cm),
         (2 * cm),
         (3 * cm),
         (2 * cm),
         (3 * cm),
         (2 * cm),
         (3 * cm),
         (2 * cm)])
        t.setStyle([('GRID',
          (0,
           2),
          (0,
           2),
          1,
          colors.black),
         ('GRID',
          (0,
           4),
          (0,
           4),
          1,
          colors.black),
         ('GRID',
          (0,
           6),
          (0,
           6),
          1,
          colors.black),
         ('VALIGN',
          (0,
           0),
          (-1,
           -1),
          'CENTER')])
        return t



    def datosTitular(self):
        tabla = []
        tabla.append([Paragraph(((('<b>Nombre :</b>  ' + self.instalacion.nombre) + '          <b>D.N.I. :</b>  ') + self.instalacion.dni), self.eNormalPortada)])
        tabla.append([Paragraph(((('<b>Domicilio :</b>  ' + self.instalacion.domicilio) + '    <b>Localidad :</b>  ') + self.instalacion.localidad), self.eNormalPortada)])
        tabla.append([Paragraph(((('<b>Provincia :</b>  ' + self.instalacion.provincia) + '    <b>Codigo Postal :</b>  ') + self.instalacion.codigoPostal), self.eNormalPortada)])
        tabla.append([Paragraph(((('<b>Correo :</b>  ' + self.instalacion.mail) + '    <b>Telefono :</b>  ') + self.instalacion.telefono), self.eNormalPortada)])
        t = Table(data=tabla)
        return t



    def datosInstalacion(self):
        tabla = []
        tabla.append([Paragraph(((('<b>Emplazamiento :</b>  ' + self.instalacion.IEmplazamiento) + '    <b>Localidad :</b>  ') + self.instalacion.Ilocalidad), self.eNormalPortada)])
        tabla.append([Paragraph(((('<b>Provincia :</b>  ' + self.instalacion.Iprovincia) + '    <b>Codigo Postal :</b>  ') + self.instalacion.IcodigoPostal), self.eNormalPortada)])
        tabla.append([Paragraph(('<b>Tipo de instalaci\xf3n :</b>  ' + self.instalacion.ITipo), self.eNormalPortada)])
        tabla.append([Paragraph(('<b>Uso al que se destina :</b>  ' + self.instalacion.IUso), self.eNormalPortada)])
        t = Table(data=tabla)
        return t



    def datosRedactor(self):
        tabla = []
        tabla.append([Paragraph(((('<b>Nombre :</b>  ' + self.instalacion.Rnombre) + '   <b>D.N.I. :</b>  ') + self.instalacion.Rdni), self.eNormalPortada)])
        tabla.append([Paragraph(((('<b>Domicilio :</b>  ' + self.instalacion.Rdomicilio) + '   <b>Localidad :</b>  ') + self.instalacion.localidad), self.eNormalPortada)])
        tabla.append([Paragraph(((('<b>Provincia :</b>  ' + self.instalacion.Rprovincia) + '   <b>C\xf3digo Postal :</b>  ') + self.instalacion.RcodigoPostal), self.eNormalPortada)])
        tabla.append([Paragraph(((('<b>e-mail :</b>  ' + self.instalacion.Rmail) + '   <b>Tel\xe9fono :</b>  ') + self.instalacion.telefono), self.eNormalPortada)])
        t = Table(data=tabla)
        return t



    def dameTablaSinCeldas(self, textos, dimensionColumna = None, seleccionado = None):
        tabla = []
        elementos = []
        for i in range(len(textos)):
            if (seleccionado.__class__ == list):
                if (seleccionado[(i - 1)] == 1):
                    imagen = Image('imagenes/prueba2.png')
                else:
                    imagen = Image('imagenes/prueba1.png')
            elif (seleccionado == (i - 1)):
                imagen = Image('imagenes/prueba2.png')
            else:
                imagen = Image('imagenes/prueba1.png')
            if (not (i == 0)):
                elementos.append(imagen)
            elementos.append(Paragraph(textos[i], self.eNormalSalto))

        tabla.append(elementos)
        tPDF = Table(data=tabla, colWidths=dimensionColumna)
        tPDF.setStyle([('TOPPADDING',
          (0,
           0),
          (-1,
           -1),
          0),
         ('BOTTOMPADDING',
          (0,
           0),
          (-1,
           -1),
          0),
         ('LEFTPADDING',
          (0,
           0),
          (-1,
           -1),
          0),
         ('RIGHTPADDING',
          (0,
           0),
          (-1,
           -1),
          0),
         ('ALIGN',
          (0,
           0),
          (-1,
           -1),
          'CENTER')])
        return tPDF



    def dameTablaEspecial(self, textos1, textos2, alturaCeldas = None, datos = None):
        numColumnas = (len(textos1) + len(textos2))
        tabla = []
        elementos = []
        for i in range(numColumnas):
            try:
                elementos.append(Paragraph(textos1[i], self.eNormal))
            except:
                elementos.append(Paragraph(' ', self.eNormal))

        tabla.append(elementos)
        elementos = []
        for i in range(numColumnas):
            indice = (i - len(textos1))
            if (indice < 0):
                elementos.append(Paragraph(' ', self.eNormal))
            elif (indice == datos):
                elementos.append(self.dameCadenaConSelector(textos2[indice], seleccionado=1))
            else:
                elementos.append(self.dameCadenaConSelector(textos2[indice]))

        tabla.append(elementos)
        tPDF = Table(data=tabla, rowHeights=alturaCeldas)
        tPDF.setStyle([('VALIGN',
          (0,
           0),
          (-1,
           -1),
          'BUTTON')])
        return tPDF



    def dameTabla(self, textos, dimensionColumna = None, dimensionSelector = None, estilo = None, estiloTabla = None, dato = None):
        if (not estilo):
            estilo = self.eNormal
        if (not estiloTabla):
            estiloTabla = [('LINEAFTER',
              (0,
               0),
              (-1,
               -1),
              0.25,
              colors.black),
             ('TOPPADDING',
              (0,
               0),
              (-1,
               -1),
              0),
             ('VALIGN',
              (0,
               0),
              (-1,
               -1),
              'CENTER')]
        tabla = []
        elementos = []
        i = 0
        for texto in textos:
            if (texto.__class__ == list):
                if (dato.__class__ == list):
                    datos = dato[i]
                else:
                    datos = dato
                elementos.append(self.dameTablaConSelector(texto, dimensionSelector, seleccionado=datos))
                i = (i + 1)
            elif (str(texto.__class__) == 'reportlab.platypus.tables.Table'):
                elementos.append(texto)
            else:
                if (texto == ' '):
                    texto = '<para> </para>'
                elementos.append(XPreformatted(texto, estilo))

        tabla.append(elementos)
        tPDF = Table(data=tabla, colWidths=dimensionColumna)
        tPDF.setStyle(estiloTabla)
        return tPDF



    def dameTablaConSelector(self, textos, dimensionSelector = None, seleccionado = None):
        tabla = []
        elementos = []
        for i in range(len(textos)):
            if (i == 0):
                if (not (textos[i] == '')):
                    elementos.append(Paragraph(textos[i], self.eNormalSalto))
            elif ((i - 1) == seleccionado):
                elementos.append(self.dameCadenaConSelector(textos[i], seleccionado=1))
            else:
                elementos.append(self.dameCadenaConSelector(textos[i]))

        tabla.append(elementos)
        tPDF = Table(data=tabla, colWidths=dimensionSelector, rowHeights=[(0.5 * cm)])
        tPDF.setStyle([('TOPPADDING',
          (0,
           0),
          (-1,
           -1),
          0),
         ('LEFTPADDING',
          (0,
           0),
          (-1,
           -1),
          0),
         ('VALIGN',
          (0,
           0),
          (-1,
           -1),
          'TOP')])
        return tPDF



    def dibujaNotas(self, textos, horizontal = None):
        tabla = []
        tabla.append([XPreformatted(textos, self.eNotas)])
        if horizontal:
            t = Table(data=tabla, colWidths=[(25.699999999999999 * cm)])
        else:
            t = Table(data=tabla, colWidths=[(19 * cm)])
        return t



    def dibujaTextos(self, textos):
        return XPreformatted(textos, self.eTextos)



    def dameCadenaConSelector(self, texto, dimension = None, seleccionado = None, estilo = None):
        if seleccionado:
            imagen = Image('imagenes/prueba2.png')
        else:
            imagen = Image('imagenes/prueba1.png')
        if (not estilo):
            estilo = self.eNormalSalto
        tabla = []
        tabla.append([imagen,
         Paragraph(texto, estilo)])
        if dimension:
            tabla = Table(data=tabla, colWidths=dimension, rowHeights=[(0.29999999999999999 * cm)])
        else:
            tabla = Table(data=tabla, colWidths=[(0.40000000000000002 * cm),
             (6 * cm)], rowHeights=[(0.29999999999999999 * cm)])
        tabla.setStyle([('ALIGN',
          (0,
           0),
          (-1,
           -1),
          'CENTER'),
         ('VALIGN',
          (0,
           0),
          (-1,
           -1),
          'TOP')])
        return tabla



    def dibujaPie(self, horizontal = None, numero = None, total = None):
        pie = Paragraph((((('<para align=right><i>P\xe1gina n\xfamero ' + numero) + ' de ') + total) + ' que forman la presente Memoria T\xe9cnica de Dise\xf1o.</i></para>'), self.ePie)
        tabla = []
        tabla.append([pie])
        if horizontal:
            t = Table(data=tabla, colWidths=[(25.699999999999999 * cm)], rowHeights=[(0.29999999999999999 * cm)])
        else:
            t = Table(data=tabla, colWidths=[(19 * cm)], rowHeights=[(0.29999999999999999 * cm)])
        return t




# local variables:
# tab-width: 4
