# emacs-mode: -*- python-*-
from wxPython.wx import *
import fpformat
class wxNumericEntry(wxTextCtrl):
    __module__ = __name__

    def __init__(self, parent, id, *args, **kwargs):
        self._wxNumericEntry__digits = '0123456789-.'
        self._wxNumericEntry__nSeparator = '.'
        self._wxNumericEntry__dSeparator = ','
        self._wxNumericEntry__nDecim = 0
        self._wxNumericEntry__iniStr = ''
        self._wxNumericEntry__endStr = ''
        self._wxNumericEntry__rightAlign = false
        self._wxNumericEntry__min = None
        self._wxNumericEntry__max = None
        self._wxNumericEntry__showHelp = true
        if kwargs.has_key('rAlign'):
            self._wxNumericEntry__rightAlign = kwargs['rAlign']
            del kwargs['rAlign']
        if kwargs.has_key('rangHelp'):
            self._wxNumericEntry__showHelp = kwargs['rangHelp']
            del kwargs['rangHelp']
        if kwargs.has_key('iniStr'):
            self._wxNumericEntry__iniStr = kwargs['iniStr']
            del kwargs['iniStr']
        if kwargs.has_key('endStr'):
            self._wxNumericEntry__endStr = kwargs['endStr']
            del kwargs['endStr']
        if kwargs.has_key('numDec'):
            self._wxNumericEntry__nDecim = kwargs['numDec']
            del kwargs['numDec']
        if kwargs.has_key('thSep'):
            self._wxNumericEntry__nSeparator = kwargs['thSep']
            del kwargs['thSep']
        if kwargs.has_key('decSep'):
            self._wxNumericEntry__dSeparator = kwargs['decSep']
            del kwargs['decSep']
        if kwargs.has_key('min'):
            self._wxNumericEntry__min = kwargs['min']
            del kwargs['min']
        if kwargs.has_key('max'):
            self._wxNumericEntry__max = kwargs['max']
            del kwargs['max']
        if kwargs.has_key('initial'):
            initial = kwargs['initial']
            del kwargs['initial']
        else:
            initial = 0
        wxTextCtrl.__init__(self, parent, id, *args, **kwargs)
        self.SetValue(initial)
        self._wxNumericEntry__FormatValue()
        EVT_CHAR(self, self.onChar)
        EVT_TEXT(self, -1, self.onText)
        EVT_SET_FOCUS(self, self.onFocus)
        EVT_KILL_FOCUS(self, self.onKillFocus)
        EVT_SIZE(self, self.onSize)



    def onSize(self, event):
        self._wxNumericEntry__FormatValue()
        event.Skip()



    def onFocus(self, event):
        self._wxNumericEntry__ValueToText()
        self.SetSelection(0, len(wxTextCtrl.GetValue(self)))
        event.Skip()



    def onKillFocus(self, event):
        self._wxNumericEntry__FormatValue()
        event.Skip()



    def onChar(self, event):
        key = event.KeyCode()
        self._wxNumericEntry__oldtext = wxTextCtrl.GetValue(self)
        if ((key < WXK_SPACE) or ((key == WXK_DELETE) or (key > 255))):
            event.Skip()
            return 
        if ((chr(key) == '.') and (self._wxNumericEntry__nDecim == 0)):
            wxBell()
            return 
        if ((chr(key) == '.') and ('.' in self._wxNumericEntry__oldtext)):
            wxBell()
            return 
        if (chr(key) in self._wxNumericEntry__digits):
            event.Skip()
            return 
        wxBell()



    def onText(self, event):
        if self._wxNumericEntry__focused:
            return 
        if ((event.GetString() != '') and (event.GetString() != '-')):
            if self._wxNumericEntry__IsValid(event.GetString()):
                self._wxNumericEntry__value = float(event.GetString())
            else:
                self._wxNumericEntry__ValueToText()
                wxBell()
        event.Skip()



    def __fmtRS(self, value):
        dc = wxClientDC(self)
        dc.SetFont(self.GetFont())
        text = value
        textwidth = dc.GetTextExtent(text)[0]
        dcwidth = self.GetClientSize()[0]
        tope = (dcwidth - dc.GetTextExtent(text[-1:])[0])
        while (textwidth <= tope):
            textwidth = dc.GetTextExtent(text)[0]
            text = (' ' + text)

        del dc
        return text[2:]



    def GetValue(self):
        if (self._wxNumericEntry__nDecim > 0):
            return float(fpformat.fix(self._wxNumericEntry__value, self._wxNumericEntry__nDecim))
        else:
            return int(self._wxNumericEntry__value)



    def GetTextValue(self):
        return fpformat.fix(self._wxNumericEntry__value, self._wxNumericEntry__nDecim)



    def SetValue(self, value):
        if ((self._wxNumericEntry__min != None) and (value < self._wxNumericEntry__min)):
            self._wxNumericEntry__value = self._wxNumericEntry__min
        elif ((self._wxNumericEntry__max != None) and (value > self._wxNumericEntry__max)):
            self._wxNumericEntry__value = self._wxNumericEntry__max
        else:
            self._wxNumericEntry__value = value
        self._wxNumericEntry__FormatValue()



    def GetMin(self):
        return self._wxNumericEntry__min



    def GetMax(self):
        return self._wxNumericEntry__max



    def SetRange(self, min, max):
        self._wxNumericEntry__min = min
        self._wxNumericEntry__max = max



    def __ValueToText(self):
        sfm = (('%.' + str(self._wxNumericEntry__nDecim)) + 'f')
        wxTextCtrl.SetValue(self, (sfm % self._wxNumericEntry__value))



    def __IsValid(self, value):
        try:
            valFloat = float(value)
        except ValueError:
            return false
        if (((self._wxNumericEntry__min == None) or (valFloat >= self._wxNumericEntry__min)) and ((self._wxNumericEntry__max == None) or (valFloat <= self._wxNumericEntry__max))):
            return true
        else:
            if self._wxNumericEntry__showHelp:
                wxMessageBox(('Min Value: %d\nMax Value: %d' % (self._wxNumericEntry__min,
                 self._wxNumericEntry__max)), 'Out of range', (wxOK | wxICON_EXCLAMATION), self)
            return false



    def __FormatValue(self):
        intString = fpformat.fix(self._wxNumericEntry__value, self._wxNumericEntry__nDecim)
        if (self._wxNumericEntry__nDecim > 0):
            intString = intString[:(-self._wxNumericEntry__nDecim - 1)]
            nstr = fpformat.fix(self._wxNumericEntry__value, self._wxNumericEntry__nDecim)[-self._wxNumericEntry__nDecim:]
            decString = (self._wxNumericEntry__dSeparator + nstr)
        else:
            decString = ''
        if (intString[:1] == '-'):
            sign = '-'
            intString = intString[1:]
        else:
            sign = ''
        thList = []
        if ((len(intString) % 3) != 0):
            thList.append(intString[:(len(intString) % 3)])
            intString = intString[(len(intString) % 3):]
        while (len(intString) != 0):
            thList.append(intString[:3])
            intString = intString[3:]

        for x in thList:
            intString = ((intString + x) + self._wxNumericEntry__nSeparator)

        intString = (sign + intString[:-1])
        self._wxNumericEntry__focused = true
        text = (((self._wxNumericEntry__iniStr + intString) + decString) + self._wxNumericEntry__endStr)
        if self._wxNumericEntry__rightAlign:
            text = self._wxNumericEntry__fmtRS(text)
        wxTextCtrl.SetValue(self, text)
        self._wxNumericEntry__focused = false




# local variables:
# tab-width: 4
